/**
 * Spiral implements a scalable construction set for golden rectangles.
 *
 * @author kvlinden
 * @version Fall, 2009
 */

final float PHI = 1.6180339887;
final int N = 4;
float a = 200;
int r=190, g=160, b=20, t=255;
size((int)(a * PHI), (int)a);
background(255);
smooth();

for (int count = 0; count < N; count++) {
  noFill();
  strokeWeight(1);
  rect(0, 0, a, a);
  fill(r, g, b, t-=255/N);
  strokeWeight(5);
  arc(a, a, a * 2, a * 2, radians(180), radians(270));
  translate(a * PHI, 0);
  rotate(PI/2.0);
  a = a / PHI;
}
