/**
 * WebDesign uses the golden ratio for web design.
 *
 * @author kvlinden
 * @version Fall, 2009
 */

final float PHI = 1.6180339887, PHI_FACTOR = 1 - 1/PHI;
int width = 600, height = int(width / PHI);
int fontSize = width/15, textPadding = width/40;

size(width, height);
stroke(0);
textFont(createFont("Calibri", fontSize));

// Header
fill(175, 100, 200);
float headHeight = height * PHI_FACTOR * PHI_FACTOR;
rect(0, 0, width, headHeight);
fill(0);
text("Header", textPadding, fontSize);

// Content
fill(50, 200, 150);
rect(0, headHeight, width / PHI, height - 2 * headHeight);
fill(0);
text("Content", textPadding, headHeight + fontSize);

// Sidebar
fill(50, 150, 225);
rect(width/PHI, headHeight, width * PHI_FACTOR, height - 2 * headHeight);
fill(0);
text("Sidebar", width/PHI + textPadding, headHeight + fontSize);

// Footer
fill(225, 200, 100);
rect(0, height - headHeight, width, headHeight);
fill(0);
text("Footer", textPadding, height - headHeight + fontSize);

save("../../../../text/c03types/webdesign.tif");


