/** 
 * Starting code for FigureDrawer which allows the user to interactively 
 * draw an ellipse by pressing the mouse on the 
 * center point and dragging the mouse to specify 
 * the radius. It sets transparent colors based on 
 * the angle of the radius.
 *
 * @author snelesen
 * @version Fall, 2010
 */
 
final int WIDTH = 500, HEIGHT = WIDTH;
int figureX, figureY;
float diameter;  

void setup() {
  size(WIDTH, HEIGHT);
  background(255);
  smooth();
  fill(255);  
}

// There must be a draw method.
void draw() {
}

/**
 * Allow the user to draw an ellipse of arbitrary size 
 * by pressing the mouse at the center point and dragging
 * the mouse to specify the radius.
 */
void mousePressed() {
  figureX = mouseX;
  figureY = mouseY;
  diameter = 0;
  stroke(0);
  strokeWeight(1);
}

void mouseDragged() { 
  int x1 = figureX, y1=figureY, x2=mouseX, y2=mouseY;
  diameter = 2 * sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
  ellipse(figureX, figureY, diameter, diameter);
}
