/**
 * BouncingBall implements simple animated movement with a movement trail.
 *
 * @author kvlinden
 * @version Fall, 2009
 */

// Use this example for chapter 5
final int WIDTH = 250, HEIGHT = WIDTH/3;
final int BALL_SIZE = 25, BALL_RADIUS = BALL_SIZE / 2;

float ballX, ballY;    // the location of the ball
float deltaX, deltaY;  // the rate of change of movement
float gravity = 0.10;  // the gravitational acceleration

void setup() {
  size(WIDTH, HEIGHT);
  smooth();

  // Start the ball in the upper left.
  ballX = 15;
  ballY = 15;

  // Set the rate of change for x and y.
  deltaX = 5;
  deltaY = 0;
}

void draw() {
  // Erase the ball at the previous location.
  noStroke();
  fill(255, 20);
  rect(0, 0, width, height);
  //background(255);

  // Draw the ball at the current location.
  stroke(0);
  fill(79, 129, 189);
  ellipse(ballX, ballY, BALL_SIZE, BALL_SIZE);

  // Move the ball to the right and down.
  ballX += deltaX;
  ballY += deltaY;
  deltaY += gravity;
  
  // Bounce the ball when it hits the floor.
  if ((ballY + BALL_RADIUS) >= height) {
    deltaY *= -0.85;
  }
  // Bounce the ball off the walls.
  if (((ballX + BALL_RADIUS) >= width) || ((ballX - BALL_RADIUS) <= 0)) {
    deltaX *= -0.85;
  }
  
  // Stop the bouncing when the ball is nearly still on the floor.
//  println(deltaX + " " + deltaY + " " + (height - (ballY + BALL_RADIUS)));
//  if (abs(deltaX) < 0.05 && abs(deltaY) < 0.05 && (height - (ballY + BALL_RADIUS)) < 1.0) {
//    deltaX = deltaY = gravity = 0;
//    ballY = height - BALL_RADIUS;
//  }
//  if (abs(deltaX) < 0.05) {
//    deltaX = 0;
//  }
//  if (abs(deltaY) < 0.075) {
//    deltaY = 0;
//  }
}

void keyPressed() {
  save("../../../../text/c05control/bouncingBall.tif");
}






