/**
 * FollowingBall implements an animated ball that follows the 
 * mouse when it is pressed. Note that it will follow the mouse
 * off the screen.
 *
 * @author kvlinden, snelesen
 * @version Fall, 2010
 */

final int WIDTH = 250, HEIGHT = WIDTH;
final int SIZE = 25;
final float FOLLOW_FACTOR = 0.1;

float ballX, ballY;

void setup() {
  size(WIDTH, HEIGHT);
  background(255);
  smooth();
  
  // Start the ball in the middle.
  ballX = WIDTH / 2;
  ballY = HEIGHT / 2;
  
  // Set the animation to 25 frames/second.
  frameRate(25);
}

void draw() {
  // Slowly whitewash the previous frames.
  noStroke();
  fill(255, 25);
  rect(0, 0, WIDTH, HEIGHT);
  
  // Draw the ball at the current location.
  stroke(0);
  fill(79, 129, 189);
  ellipse(ballX, ballY, SIZE, SIZE);
}

void mouseDragged() {
  // Move the ball part-way toward the mouse location
  ballX += (mouseX - ballX) * FOLLOW_FACTOR;
  ballY += (mouseY - ballY) * FOLLOW_FACTOR;
}

void keyPressed() {
  // Save a snapshot of the animation.
  save("../../../../text/c04methods/followingBall.tif");
}



