/**
 * Pacman implements a pacman figure (see http://en.wikipedia.org/wiki/Pacman)
 * that follows the mouse when it is pressed. Note that it will follow the 
 * mouse off the screen.
 *
 * @author kvlinden
 * @version Fall, 2009
 */

final int SIZE = 25;
final float FOLLOW_FACTOR = 0.10;
int width = 300, height = width;
float x1, y1, x2, y2, targetX, targetY;
int biteFactor = 0;

void setup() {
  size(width, height);
  //smooth();  // remove for an authentic pixilated figure
  frameRate(8);
  x1 = y1 = 10;
  x2 = width - 10;
  y2 = height - 10;
  targetX = width / 2;
  targetY = height / 2;
}

void draw() {
  background(0);
  fill(255, 255, 0);
  // this computes dx and dy 3 times - yuck!
  // but without that there is no need for methods, and 
  //    the pacmen extension may require this - hmm...
  x1 = computeNewCoordinate(x1, targetX); 
  y1 = computeNewCoordinate(y1, targetY); 
  drawPacman(x1, y1, computeFacingAngle(x1, y1, targetX, targetY));
//  x2 = computeNewCoordinate(x2, targetX); 
//  y2 = computeNewCoordinate(y2, targetY); 
//  drawPacman(x2, y2, computeFacingAngle(x2, y2, targetX, targetY));
  biteFactor = (biteFactor + 1) % 2;
}

void mouseMoved() {
  targetX = mouseX;
  targetY = mouseY;
}

float computeNewCoordinate(float current, float target) {
  return current + (target - current) * FOLLOW_FACTOR;
}

float computeFacingAngle(float x, float y, float targetX, float targetY) {
  return atan2(targetY - y, targetX - x);
}

void drawPacman(float x, float y, float angle) {
  noStroke();
  fill(255, 255, 0);
  ellipse(x, y, SIZE, SIZE);
  fill(0);
  arc(x, y, SIZE, SIZE, -0.125*PI*biteFactor + angle, 0.125*PI*biteFactor + angle);
}

void keyPressed() {
  save("../../../../text/c04methods/pacmen.tif");
}


