/* Draws ellipses in random locations, where their color
 * is deteremined by the location
 * Author: S. Nelesen
 * Date: Fall 2011
 */
 
void setup(){
  final int WIDTH = 400, HEIGHT=400;
  size(WIDTH, HEIGHT);
  background(255);
  smooth();
  
  randEllipse(WIDTH, HEIGHT);
  randEllipse(WIDTH, HEIGHT);
  randEllipse(WIDTH, HEIGHT);
  randEllipse(WIDTH, HEIGHT);
}

/* randEllipse draws randomly sized and positioned ellipses
 * and uses location to determine color
 * @param srcnW is the width of the graphical output window
 * @param scrnH is the height of the graphical output window
 */
void randEllipse(int scrnW, int scrnH){
  //start by determining random location and size
  int halfW = scrnW/2;
  int halfH = scrnH/2;
  float ellipseX = random(scrnW);
  float ellipseY = random(scrnH);
  float ellipseW = random(halfW);
  float ellipseH = random(halfH);
  
  //Given location, determine color
  //upper left green
  if (ellipseX < halfW && ellipseY < halfH){
    stroke(0, 255, 0);
    fill(0, 255, 0);
  }
  //lower left red
  else if (ellipseX < halfW){
    stroke(255, 0, 0);
    fill(255, 0, 0);
  }
  //upper right blue 
  else if (ellipseX > halfW && ellipseY < halfH){
    stroke(0, 0, 255);
    fill(0, 0, 255);
  }
  //lower right yellow
  else {
    stroke(255, 255, 0);
    fill(255, 255, 0);
  }
  
  //draw the ellipse
  ellipse(ellipseX, ellipseY, ellipseW, ellipseH);
}
  
  
  
  
  
  
