/**
 * SimpleCircles draw two concentric circles on a background 
 * and allows the user to click on the circles or the background
 * to change them to a random color.
 *
 * The intent is to build this example up iteratively
 *
 * @author kvlinden
 * @version Spring, 2012
 */

final int WIDTH = 300, HEIGHT = WIDTH;
int ellipseX, ellipseY, ellipse1Diameter, ellipse1Radius, ellipse2Diameter, ellipse2Radius;
color ellipse1Color, ellipse2Color, backgroundColor;

void setup() {
  size(WIDTH, HEIGHT);
  smooth();
  ellipseX = WIDTH / 2; 
  ellipseY = HEIGHT / 2;
  ellipse1Diameter = 150;
  ellipse1Radius = ellipse1Diameter / 2;
  ellipse2Diameter = 75;
  ellipse2Radius = ellipse2Diameter / 2;
  ellipse1Color = color(255);
  ellipse2Color = color(255);
  backgroundColor = color(255);
}

void draw() {
  background(backgroundColor);
  strokeWeight(2);
  fill(ellipse1Color);
  ellipse(ellipseX, ellipseY, ellipse1Diameter, ellipse1Diameter);
  fill(ellipse2Color);
  ellipse(ellipseX, ellipseY, ellipse2Diameter, ellipse2Diameter);
  strokeWeight(5);
  point(ellipseX, ellipseY);
}

void mouseClicked() {
  if (dist(mouseX, mouseY, ellipseX, ellipseY) <= ellipse2Radius) {
    ellipse2Color = computeRandomColor();
  } 
  else if (dist(mouseX, mouseY, ellipseX, ellipseY) <= ellipse1Radius) {
    ellipse1Color = computeRandomColor();
  } 
  else {
    backgroundColor = computeRandomColor();
  }
}

int computeRandomColor() {
  return color(random(255), random(255), random(255));
}

