package c06java.lecture;

import java.util.Scanner;

/**
 * This application reads a number of hours worked and a wage rate from the user
 * and prints pay based on a 40-hour work week and time-and-a-half overtime.
 * 
 * Test cases:
 * 10 hours at $20/hour: 200
 * 40 hours at $10/hour: 400
 * 50 hours at $1/hour: 55
 * 0 hours at $0/hour: 0
 * -1 hours at $5/hour: 0
 * 
 * @author kvlinden
 * @version Spring, 2012
 */
public class ComputeWage {

	/**
	 * computeWages computes wages for the given hours and rate using a 40-hour
	 * work week and time-and-a-half for overtime. If the hours is negative, it
	 * returns 0.
	 * 
	 * @param hours
	 *            the hours worked
	 * @param rate
	 *            the standard rate of pay
	 * @return the total, weekly pay including overtime
	 */
	private static double computeWages(double hours, double rate) {
		if (hours < 0) {
			return 0.0;
		} else if (hours <= 40) {
			return hours * rate;
		} else {
			return (40 + (hours - 40) * 1.5) * rate;
		}
	}

	/**
	 * The main method implements the console-based interface.
	 */
	public static void main(String[] args) {
		Scanner keyboard = new Scanner(System.in);
		System.out.println("Welcome to the wage calculator!");
		System.out.print("\tEnter hours: ");
		double hours = keyboard.nextDouble();
		System.out.print("\tEnter rate: ");
		double rate = keyboard.nextDouble();
		System.out.println("Pay: " + computeWages(hours, rate));

	}

}
