package c06java.text;

import java.util.Scanner;

/**
 * ComputeInterest uses a console interface to build a interest computation
 * application. The user enters a balance and the program computes and prints
 * the interest rate based on a hard-coded interest rate.
 * 
 * @author kvlinden
 * @version Spring, 1012
 */
public class ComputeInterestWithMethod {

	public static final double RATE = 0.06; // The hard-coded interest rate

	/**
	 * This method computes the interest rate for a given balance based on a
	 * hard-coded constant.
	 * 
	 * @param balance
	 *            the amount on which to compute the interest
	 * @return the appropriate amount of interest
	 */
	public static double computeInterest(double balance) {
		return balance * RATE;
	}

	/**
	 * This method drives the console-based interface for the application.
	 * 
	 * @param args
	 *            ignored
	 */
	public static void main(String[] args) {
		System.out.print("Please enter your account balance: $");
		Scanner keyboard = new Scanner(System.in);
		double balance = keyboard.nextDouble();
		System.out.printf("\tInterest: $%.2f (using a %2.1f%% rate)", computeInterest(balance),
				RATE * 100);
	}

}
