package c07repetition.lecture.mandelbrot;

import junit.framework.Assert;

import org.junit.Test;

/**
 * This is a JUnit tests that tests the Complex class
 * 
 * @author gao2
 * @version Fall, 2009
 * @author modified by kvlinden
 */

public class ComplexTest {

	@Test
	public void complexTest() {
		Complex z = new Complex(2, 4);
		Complex c = new Complex(6, 8);
		try {
			Assert.assertEquals(4.47213595, z.mod(), 1e-6);
			// test the addition function
			Complex a = new Complex(z.plus(c));
			// checks real portion
			Assert.assertEquals(8, a.real(), 1e-6);
			// checks imaginary portion
			Assert.assertEquals(12, a.imag(), 1e-6);

			// test the subtraction function
			Complex b = new Complex(z.minus(c));
			// checks real portion
			Assert.assertEquals(-4, b.real(), 1e-6);
			// checks imaginary portion
			Assert.assertEquals(-4, b.imag(), 1e-6);

			// test the multiplication function
			Complex d = new Complex(z.times(c));
			// checks real portion
			Assert.assertEquals(-20, d.real(), 1e-6);
			// checks imaginary portion
			Assert.assertEquals(40, d.imag(), 1e-6);

			// test the division function
			Complex e = new Complex(z.div(c));
			// checks real portion
			Assert.assertEquals(0.44, e.real(), 1e-6);
			// checks imaginary portion
			Assert.assertEquals(0.08, e.imag(), 1e-6);

			// test the exponent function
			Complex f = new Complex(z.exp());
			// checks real portion
			Assert.assertEquals(-4.829809383269385, f.real(), 1e-6);
			// checks imaginary portion
			Assert.assertEquals(-5.5920560936409816, f.imag(), 1e-6);

			// test the log function
			Complex g = new Complex(z.log());
			// checks real portion
			Assert.assertEquals(1.4978661367769956, g.real(), 1e-6);
			// checks imaginary portion
			Assert.assertEquals(1.1071487177940904, g.imag(), 1e-6);

			// test the square root function
			Complex h = new Complex(z.sqrt());
			// checks real portion
			Assert.assertEquals(1.7989074399478673, h.real(), 1e-6);
			// checks imaginary portion
			Assert.assertEquals(1.1117859405028423, h.imag(), 1e-6);
		} catch (Exception e) {

		}
	}

}
