/* SineWave plots the sine wave from 0 to 2*PI.
 *
 * @author kvlinden
 * @version 14july2009
 */
int width = 360, height = width/2;

void setup() {
  size(width, height);
  textFont(loadFont("Calibri-14.vlw"));
  noLoop();
  fill(0);
}

void draw() {
  line(0, height/2, width, height/2);  // x axis
  line(0, 0, 0, height);               // y axis
  for (int x = 0; x <= width; x++) {
    if (x % 90 == 0) {
      line(x, height/2-5, x, height/2+5);
      text("PI*" + radians(x)/PI, x, height/2 + 20);
    }
    point(x, translateY(sin(radians(x)) * height/2));
  }
}

// This method inverts the y value for plotting on the canvas.
float translateY(float value) {
  return value * -1 + height/2;
}

void keyPressed() {
  save("../../../../text/c05control/sinePlot.tif");
}



