// curvedLines draws parabolae.
// It draws them "upside down" according to the orientation 
// of graphic output and translates the output to the right 
// (by width/2) so that the whole parabola can be seen.
// kvlinden, 15july2009

void setup() {
  size(200, 250);
  //smooth();
  noLoop();
}

void draw() {
  drawAxes();
  drawParabola(0.01, color(0, 102, 153)); // blue
  drawParabola(0.1, color(50, 152, 0));   // green
  drawParabola(1.0, color(152, 3, 0));    // red
}

void drawAxes() { 
  strokeWeight(1);
  stroke(0);
  line(width/2, 0, width/2, height);
  line(0, 0, width, 0);
}

void drawParabola(float c, int myColor) {
  strokeWeight(5);
  stroke(myColor);
  for (float x = -width/2; x < width/2; x++) {
    point(x + width/2, pow(x, 2) / 4.0 * c);
  }
}

void keyPressed() {
  save("../../../../text/c05control/curvedLines.tif");
}



