final int SIZE = 300;

float mySlope = 1.0;
float myYIntercept = 0.2;
int myWidth = SIZE, myHeight = SIZE;
int myXAxis = myHeight/2;
int myYAxis = myWidth/2;
float myXMax = 1;
float myScale = (myWidth - myYAxis) / myXMax;
float myXMin = -1 * (myWidth - myYAxis) / myScale;
float myYMax = (myHeight - myXAxis) / myScale;
float myYMin = -1 * (myHeight - myXAxis) / myScale;

void setup() {
  size(SIZE, SIZE);
  smooth();
}

void draw() {
  background(255);
  drawAxes(myXAxis, myYAxis);
  plotFunction();
}

void drawAxes(int x, int y) {
  stroke(200);
  line(0, myXAxis, myWidth, myXAxis); // x axis
  line(myYAxis, 0, myYAxis, myHeight); // y axis
}

void plotFunction() {
  stroke(0);
  for (float x = myXMin; x <= myXMax; x += 0.0001) {
    point(translateX(x), translateY(computeY(x)));
  }
}

float translateX(float value) {
  return value * myScale + myYAxis;
}

float translateY(float value) {
  return value * -1 * myScale + myXAxis;
}

float computeY(float x) {
  return mySlope * x + myYIntercept;
}

void keyPressed() {
  save("../../../../web/c08java/processingPlotter.png");
}




