/* functionChooser lets the user choose a function, but doesn't plot it.
 * It does print a message indicating the current function drawing mode.
 *
 * @author kvlinden
 * @version 14july2009
 */

final int SQRT = 0, SQ = 1, LINE = 2;
int functionMode = SQRT;

int menuWidth = 100, menuHeight = menuWidth/2, xAxisWidth = 300, width = menuWidth + xAxisWidth, height = xAxisWidth;
int xAxis = height-25, yAxis = 25;

void setup() {
  size(width, height);
  textFont(loadFont("Calibri-20.vlw"));
}

void draw() {
  background(255);
  drawMenu();
  drawAxes(xAxis, yAxis);
  plotFunction();
}

void drawMenu() {
  fill(255);
  rect(0, 0, menuWidth, menuHeight);
  rect(0, menuHeight, menuWidth, menuHeight);
  rect(0, menuHeight * 2, menuWidth, menuHeight);
  fill(0);
  text("sqrt(x)", 10, 20);
  text("sq(x)", 10, menuHeight + 20);
  text("0.5x * 0.3", 10, menuHeight*2 + 20);
}

void drawAxes(int x, int y) {
  stroke(200);
  line(menuWidth, xAxis, width, xAxis); // x axis
  line(menuWidth + yAxis, 0, menuWidth + yAxis, height); // y axis
}

void mouseClicked() {
  if (mouseX < menuWidth) {
    if ((mouseY >= 0) && (mouseY < menuHeight)) {
      functionMode = SQRT;
    } 
    else if ((mouseY >= menuHeight) && (mouseY < menuHeight * 2)) {
      functionMode = SQ;
    }
    else if ((mouseY >= menuHeight * 2) && (mouseY < menuHeight * 3)) {
      functionMode = LINE;
    }
  }
}

void plotFunction() {
  switch(functionMode) {
  case SQRT:
    text("the square root function...", 150, 100);
    return;
  case SQ:
    text("the square function...", 150, 100);
    return;
  case LINE:
    text("the line function...", 150, 100);
    return;
  default:  
    text("invalid function mode...", 150, 100);
    return;
  }
}

void keyPressed() {
  save("../../../../text/c05control/functionPlot.tif");
}












