/* functionPlotter plots the function f(x) = sqrt(x) from 0 to 1.
 *
 * @author kvlinden
 * @version 14july2009
 */
 
int width = 300, height = width;
int xAxis = height-25, yAxis = 25;
float xMax = 1.0, scale = (width - yAxis) / xMax, xMin = -yAxis / scale;

void setup() {
  size(width, height);
  background(255);
  drawAxes(xAxis, yAxis);
  plotFunction();
  noLoop();
}

void plotFunction() {
  stroke(0);
  for (float x = 0; x <= xMax; x += 0.0001) {
    point(translateX(x), translateY(computeY(x)));
  }
}

float translateX(float value) {
  return value * scale + yAxis;
}

float translateY(float value) {
  return value * -1 * scale + xAxis;
}

float computeY(float x) {
  return sqrt(x);
}

void drawAxes(int x, int y) {
  stroke(200);
  line(0, xAxis, width, xAxis); // x axis
  line(yAxis, 0, yAxis, height); // y axis
}

void keyPressed() {
  save("../../../../text/c05control/functionPlot.tif");
}

