/* ellipseSpring allows the user to drag an ellipse around.
 * The system moves the ellipse back to the center when the 
 * user isn't dragging it.
 *
 * @author kvlinden
 * @version 16july2009
 */

int width = 300, height = width, ellipseX = width / 2, ellipseY = height / 2, ellipseDiameter = 100, ellipseRadius = ellipseDiameter / 2;

void setup() {
  size(width, height);
  smooth();
}

void draw() {
  background(255);
  ellipse(ellipseX, ellipseY, ellipseDiameter, ellipseDiameter);
  strokeWeight(5);
  point(ellipseX, ellipseY);
  if (!mousePressed) {
    ellipseX -= (ellipseX - (width / 2)) * 0.1;
    ellipseY -= (ellipseY - (height / 2)) * 0.1;
  }
}

void mouseDragged() {
  if ((abs(mouseX - ellipseX) <= ellipseRadius) && (abs(mouseY - ellipseY) <= ellipseRadius)) {
    ellipseX += mouseX - pmouseX;
    ellipseY += mouseY - pmouseY;
  }
}

void keyPressed() {
  save("../../../../text/c05control/ellipseSpring.tif");
}








