/* polygonAnimation animates an approximation of a circle 
 * using polygons with successively larger numbers of sides.
 *
 * @author kvlinden, snelesen
 * @version aug2010
 */

final int WIDTH = 300, HEIGHT = WIDTH;
int polygonX, polygonY, polygonDiameter, polygonRadius, numSides;

void setup() {
  size(WIDTH, HEIGHT);
  background(255);
  smooth();
  polygonX = WIDTH / 2;
  polygonY = HEIGHT/ 2;
  polygonDiameter = WIDTH;
  polygonRadius = polygonDiameter / 2;
  numSides = 3;
  frameRate(4);
}

// Repeatedly draw n-gons of increasing n.
void draw() {
  background(255);
  //ellipse(polygonX, polygonY, polygonDiameter, polygonDiameter);
  strokeWeight(5);
  point(polygonX, polygonY);
  drawPolygon(numSides++);
}

// Draw a n-gon with the given number of sides.
void drawPolygon(int sides) {
  if (sides < 3) {
    println("invalid number of sides: " + sides + "\nsimplePolygon exiting");
    exit();
  }
  float angle = 360.0 / sides, theta1, theta2;
  strokeWeight(1);
  for (int i = 0; i < sides; i = i+1) {
    theta1 = radians(angle * i);
    theta2 = radians(angle * (i + 1));
    line(polygonX + cos(theta1) * polygonRadius, 
    polygonY + sin(theta1) * polygonRadius, 
    polygonX + cos(theta2) * polygonRadius, 
    polygonY + sin(theta2) * polygonRadius);
  }
}

void keyPressed() {
  save("../../../../text/c05control/polygonAnimation.tif");
}







