/* simpleEllipse allows the use to change the color, either
 * in the circle or outside of it.
 *
 * @author kvlinden
 * @version 16july2009
 */

int width = 300, height = width;
int ellipseX, ellipseY, ellipseRadius, ellipseDiameter;
color fillColor, backgroundColor;

void setup() {
  size(width, height);
  fillColor = color(255);
  backgroundColor = color(255);
  smooth();
  ellipseX = width / 2;
  ellipseY = height / 2;
  ellipseRadius = 50;
  ellipseDiameter = ellipseRadius * 2;
}

void draw() {
  background(backgroundColor);
  strokeWeight(2);
  fill(fillColor);
  ellipse(ellipseX, ellipseY, ellipseDiameter, ellipseDiameter);
  strokeWeight(5);
  point(ellipseX, ellipseY);
}

void mouseClicked() {
  if (dist(mouseX, mouseY, ellipseX, ellipseY) <= ellipseRadius) {
    fillColor = color(random(255), random(255), random(255));
  } 
  else {
    backgroundColor = color(random(255), random(255), random(255));
  }
}

void keyPressed() {
  save("simpleEllipse.tif");
}









