/* simplePolygon draws a polygon with a specified number of sides.
 *
 * @author jnyhoff
 * @version 12may2009
 * @version adapted by kvlinden, 16may2009
 */

int width = 300, height = width, polygonX = width / 2, polygonY = height / 2, polygonDiameter = width, polygonRadius = polygonDiameter / 2;
int numSides = 3;

void setup() {
  size(width, height);
  smooth();
  noLoop();
}

void draw() {
  background(255);
  //ellipse(polygonX, polygonY, polygonDiameter, polygonDiameter);
  strokeWeight(5);
  point(polygonX, polygonY);
  drawPolygon(numSides);
}

void drawPolygon(int sides) {
  if (sides < 3) {
    println("invalid number of sides: " + sides + "\nsimplePolygon exiting");
    exit();
  }
  float angle = 360.0 / sides, theta1, theta2;
  strokeWeight(1);
  for (int i = 0; i < sides; i = i+1) {
    theta1 = radians(angle * i);
    theta2 = radians(angle * (i + 1));
    line(polygonX + cos(theta1) * polygonRadius, 
    polygonY + sin(theta1) * polygonRadius, 
    polygonX + cos(theta2) * polygonRadius, 
    polygonY + sin(theta2) * polygonRadius);
  }
}

void keyPressed() {
  save("../../../../text/c05control/simplePolygon.tif");
}







