/** 
 * Tree draws a tree fractal using recursion.
 * (reference: Curran Kelleher, "Recursive Structures and Processes", MIT, 2007)
 *
 * @author kvlinden
 * @version Fall, 2009
 */

final int N = 16;
int n;

void setup() {
  size(800, 800);
  frameRate(5);
  smooth();
  n = 0;
}

void draw() {
  background(255);
  drawTree(width/2, height, height*0.4, PI/2, n);
  if (n < N) {
    n++;
  } 
  else {
    stop();
  }
}

void drawTree(float x1, float y1, float length, float angle, int depth) {
  float x2 = x1 - cos(angle) * length;
  float y2 = y1 - sin(angle) * length;
  if (depth < 10) {
    stroke(0, 200, 0);
    strokeWeight(1);
  } else {
    stroke(95, 75, 50);
    strokeWeight(depth-8);
  }
  line(x1, y1, x2, y2);
  if (depth > 0) {
    drawTree(x2, y2, length*0.592, angle+PI/4, depth-1);
    drawTree(x2, y2, length*0.592, angle-PI/4, depth-1);
  }
}

void keyPressed() {
  save("../../../web/c05bcontrol/tree.png");
}


