/**
 * CentralAmericaPopulationData represents and prints the population of the seven 
 * Central American states using data from Wikipedia.
 *
 * data: http://en.wikipedia.org/wiki/Central_america
 * country codes: see http://www.iso.org/iso/iso_3166_code_lists
 *
 * @author: kvlinden
 * @version Fall, 2009
 */

//String[] populationCountries = { 
//  "Belize", "Costa Rica", "El Salvador", "Guatemala", "Honduras", "Nicaragua", "Panama" };
//int[] populationValues = { 
//  294385, 4133884, 6948073, 12728111, 7483763, 5675356, 3242173 };
String[] populationCountries;
int[] populationValues;
int populationAverage, populationMaximum, populationMinimum, populationTotal;

void setup() {
  loadPopulationData("populationData.txt");
  for (int i = 0; i < populationCountries.length; i++) {
    println(populationCountries[i] + ": " + populationValues[i]);
  }
  //println("Total Population: " + computeTotal(populationValues));
  computeStatistics(populationValues);
  println("total: " + populationTotal);
  println("average: " + populationAverage);
  println("maximum: " + populationMaximum);
  println("minimum: " + populationMinimum);
  //  saveStrings("data/populationCountries.txt", populationCountries);
  //  String[] populationValuesStrings = new String[populationValues.length];
  //  for (int i = 0; i < populationValues.length; i++) {
  //    populationValuesStrings[i] = populationValues[i] + "";
  //  }
  //  saveStrings("data/populationValues.txt", populationValuesStrings);
}

int computeTotal(int[] values) {
  int result = 0;
  for (int i = 0; i < values.length; i++) {
    result += values[i];
  }
  return result;
}

void computeStatistics(int[] values) {
  populationTotal = 0;
  populationMaximum = Integer.MIN_VALUE;
  populationMinimum = Integer.MAX_VALUE;
  for (int i = 0; i < values.length; i++) {
    populationTotal += values[i];
    if (values[i] > populationMaximum) {
      populationMaximum = values[i];
    }
    if (values[i] < populationMinimum) {
      populationMinimum = values[i];
    }
  }
  populationAverage = populationTotal/values.length;
}

void loadPopulationData(String dataFilename) {
  String[] dataLines = loadStrings(dataFilename);
  populationCountries = new String[dataLines.length];
  populationValues = new int[dataLines.length];
  String[] tokens;
  for (int i = 0; i < dataLines.length; i++) {
    tokens = split(dataLines[i], " ");
    populationCountries[i] = tokens[0];
    populationValues[i] = int(tokens[1]);
  }
}



















