/**
 * BounceBall implements a simple paddleball game with multiple balls.
 *
 * @author kvlinden
 * @version Fall, 2009
 */

final int BALL_RADIUS = 20, PADDLE_WIDTH = BALL_RADIUS * 5, BALL_COUNT = 20;

Ball[] balls;
//Ball ball;
Paddle paddle;
float phaseIn;

void setup() {
  size(400, 200);
  background(255);
//  ball = new Ball(width - BALL_RADIUS, BALL_RADIUS, BALL_RADIUS, random(-2.0, 2.0), -0.0, 0.0017, 1.0);
  balls = new Ball[BALL_COUNT];
  for (int i = 0; i < balls.length; i++) {
    balls[i] = new Ball(random(width - BALL_RADIUS * 2) + BALL_RADIUS, BALL_RADIUS, BALL_RADIUS, random(-2.0, 2.0), -0.0, 0.0017, 1.0);
  }
  paddle = new Paddle(width / 2, PADDLE_WIDTH, width, height);
  phaseIn = 0.0;
}

void draw() {
  // Slowly whitewash the previous frames.
  noStroke();
  fill(200, 50);
  rect(0, 0, width, height);
  
//  ball.render();
//  ball.move(paddle);
  for (int i = 0; i < balls.length && i < phaseIn; i++ ) {
    balls[i].render();
    balls[i].move(paddle);
  }
  paddle.render();
  phaseIn += 0.1;
}

void mouseMoved() {
  paddle.move(mouseX);
}

void keyPressed() {
  save("../../../../text/c07classes/bounceBalls.tif");
}



