/**
 * Paddle implements a movable paddle. The movement must be handled by the calling program.
 *
 * @author kvlinden
 * @version Fall, 2009
 */
 
 class Paddle {
  
  private final int HEIGHT = 5;
  
  private float myX;  // must be between 0 and the screen width
  private int myWidth, myHeight, myScreenWidth, myScreenHeight;
  
  // default constructor (assumes screen width of 200)
  public Paddle() {
    myX = 25;
    myWidth = 50;
    myHeight = HEIGHT;
    myScreenWidth = 200;
  }
  
  // explicit-value constructor
  public Paddle(float x, int paddleWidth, int screenWidth, int screenHeight) {
    myX = constrain(x, 0, screenWidth);
    myWidth = constrain(paddleWidth, 0, screenWidth);
    myHeight = HEIGHT;
    myScreenWidth = screenWidth;
    myScreenHeight = screenHeight;
  }
  
  // accessor methods
  public float getX() {
    return myX;
  }
  public int getWidth() {
    return myWidth;
  }
  public int getHeight() {
    return myHeight;
  }
  
  // mutator method
  public void move(float x) {
    myX = constrain(x, 0, myScreenWidth);
  }
  
  // utility method
  public void render() {
    stroke(0);
    fill(255);
    rect(myX - myWidth / 2, myScreenHeight - myHeight, myWidth, myHeight);
  }
  
}
