/* Ball implements a single, bounceable ball.
 *
 * @author kvlinden
 * @version 28july2009
 */

class Ball {

  float myX, myY, myRadius, myVelocityX, myVelocityY, myAccelerationX, myAccelerationY;
  color myColor;

  Ball(float x, float y, float radius, float velocityX, float velocityY, float accelerationX, float accelerationY) {
    myX = x;
    myY = y;
    myRadius = radius;
    myVelocityX = velocityX;
    myVelocityY = velocityY;
    myAccelerationX = accelerationX;
    myAccelerationY = accelerationY;
    myColor = color(random(255), random(255), random(255));
  }

  void display() {
    stroke(0);
    fill(myColor);
    ellipse(myX, myY, myRadius * 2, myRadius * 2);
  }

  void move() {
    myX += myVelocityX;
    myY += myVelocityY;
    if (hitsSide()) {
      myVelocityX *= -1;
      myAccelerationX *= -1;
    }
    if (hitsBottom()) {
      myY = height - myRadius;
      myVelocityY *= -1;
    }
    if (abs(myVelocityX) < 0.01) {
      myVelocityX = 0.0;
    }
    myVelocityX += myAccelerationX;
    myVelocityY += myAccelerationY;
  }

  boolean hitsSide() {
    return (myX - myRadius <= 0) || (myX + myRadius >= width);
  }

  boolean hitsBottom() {
    return abs(myY + myRadius - height) <= myVelocityY;
  }

}


