/**
 * BouncingBalls implements a bunch of bouncing balls and a paddle.
 *
 * @author kvlinden
 * @version Fall, 2009
 */

final float BALL_RADIUS = 10.0;
final int BALL_COUNT = 10;

//Ball ball;
Ball[] balls;
float phaseIn;

void setup() {
  size(300, 500);
  background(200);
//  ball = new Ball(width - BALL_RADIUS, height - BALL_RADIUS, BALL_RADIUS, -2.0, -40.0, 0.0015, 2.0);
  balls = new Ball[BALL_COUNT];
  float xVelocity, xAcceleration;
  for (int i = 0; i < balls.length; i++) {
    xVelocity = random(-2.0, 2.0);
    xAcceleration = 0.0017;
    if (xVelocity > 0) {
      xAcceleration *= -1;  // The x acceleration must have the opposite sign from the x velocity.
    } 
    balls[i] = new Ball(random(width - BALL_RADIUS * 2) + BALL_RADIUS, BALL_RADIUS, BALL_RADIUS, xVelocity, -0.0, xAcceleration, 1.0);
  }
  phaseIn = 0.0;
}

void draw() {
  noStroke();
  fill(200, 50);
  rect(0, 0, width, height);
//  ball.display();
//  ball.move();
  for (int i = 0; i < balls.length && i < phaseIn; i++ ) {
    balls[i].display();
    balls[i].move();
  }
  phaseIn += 0.1;
}

void keyPressed() {
  save("../../../../text/07classes/balls.tif");
}

