/**
 * PinBall extends bounceBall to a simple pinball game with
 * some random balls with fixed positions serving as targets.
 * The main ball bounced off the walls, paddle and targets.
 *
 * @author kvlinden
 * @version Fall, 2009
 */

final int TARGET_COUNT = 4, BALL_RADIUS = 10, PADDLE_WIDTH = BALL_RADIUS * 10;

Ball ball;
Ball[] targets;
Paddle paddle;

public void setup() {
  size(500, 400);
  background(255);
  targets = new Ball[TARGET_COUNT];
  int targetRadius;
  for (int i = 0; i < targets.length; i++) {
    targetRadius = (int)random(BALL_RADIUS * 2, BALL_RADIUS * 5);
    targets[i] = new Ball(random(targetRadius, width - targetRadius), random(targetRadius, height - targetRadius * 2), 
    targetRadius);
//    targets[i] = new Ball(170, height/2, 50);
  }
  ball = new Ball(width - BALL_RADIUS, height - BALL_RADIUS, BALL_RADIUS, -2.0, -15.0, 0.005, 0.3);
  paddle = new Paddle(width / 2, PADDLE_WIDTH);
//  frameRate(10);
}

void draw() {
  // Slowly whitewash the previous frames.
  noStroke();
  fill(200, 25);
  rect(0, 0, width, height);
  
  // Process the moving pinball.
  ball.render();
  ball.move(paddle);
  
  // Process the target bumpers.
  for (int i = 0; i < targets.length; i++) {
    targets[i].render();
    // Bounce the ball off the target if appropriate.
    if (ball.hitsTarget(targets[i])) {
      ball.collide(targets[i]);
    }
  }

  // Draw the paddle.
  paddle.render();
}

void mouseMoved() {
  paddle.move(mouseX);
}

void keyPressed() {
  save("../../../../text/07classes/pinBall.tif");
}














