package c10quality.lecture.icecream;


import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import org.junit.Test;

public class IceCreamOrderTest {

	private static final double DOUBLE_EPSILON = 1e-3;

	@Test
	public void doNothingTest(){
	}


	//	@Test
	//	public void failTest(){
	//		fail("Here is one way to fail");
	//	}


	@Test
	public void doNothingInterestingTest(){
		assertTrue(true);
		assertEquals(1, 1);
	}

	@Test
	public void defaultConstructorTest(){
		IceCreamOrder order = new IceCreamOrder();
		assertEquals(1, order.getScoops());
		assertTrue(order.getFlavor().equals("Vanilla"));
		assertEquals(order.getFlavor(), "Vanilla");
	}

	private void badOrderConstructionUtility  (int scoops, String flavor, boolean status) {
		try {
			new IceCreamOrder(scoops, flavor, status);
			fail("inappropriately constructed a " 
					+ scoops + " scoop(s) of " + flavor  
					+ " Order");
		} catch (Exception e) {
			// It should throw this exception!
		}
	}

	@Test
	public void badOrderTest(){
		badOrderConstructionUtility(-2, "Vanilla", false);
		badOrderConstructionUtility(0, "Cookie Dough", false);
	}
	
	private void goodOrderConstructionUtility(int scoops, String flavor, boolean status) {
		try {
			new IceCreamOrder(scoops, flavor, status);
		} catch (Exception e) {
			fail("inappropriately failed to construct a " 
					+ scoops + " scoop(s) of " + flavor  
					+ " Order");
		}
	}
	
	@Test 
	public void goodOrderTest(){
		goodOrderConstructionUtility(4, "Rocky Road", false);
		goodOrderConstructionUtility(2, "Mint Chocolate Chip", true);		
	}
}
