package c10quality.lecture.person;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import java.util.Calendar;
import java.util.GregorianCalendar;

import org.junit.Test;

import c10quality.lecture.person.Person.Gender;

public class PersonTest {

	@Test
	public void defaultConstructorTests() {
		Person p1 = new Person();
		assertEquals("Mr. John Doe", p1.toString());
		assertEquals(0, p1.getAge());
	}

	@Test
	public void explicitValueConstructorTests() {
		try {
			Person p1 = new Person("Joe", "Blow", Gender.MALE, new GregorianCalendar(1990,
					Calendar.JANUARY, 1));
			assertEquals(22, p1.getAge());
			p1 = new Person("Jane", "Doe", Gender.FEMALE, new GregorianCalendar(2000,
					Calendar.JANUARY, 1));
			assertEquals("Ms. Jane Doe", p1.toString());
			assertEquals(12, p1.getAge());
		} catch (Exception e) {
			fail("inappropriate exception thrown...");
		}
	}

	@Test
	public void badExplicitValueConstructorTests() {
		GregorianCalendar bonoBirthdate = new GregorianCalendar(1960, Calendar.MAY, 10);
		badExplicitValueConstructorUtility("bono", null, Gender.MALE, bonoBirthdate);
		badExplicitValueConstructorUtility(null, "bono", Gender.MALE, bonoBirthdate);
		// badExplicitValueConstructorUtility("Paul", "Hewson", ' ',
		// bonoBirthdate);
	}

	private void badExplicitValueConstructorUtility(String firstName, String lastName,
			Gender gender, GregorianCalendar birthdate) {
		try {
			new Person(firstName, lastName, gender, birthdate);
			fail("appropriate exception not thrown...");
		} catch (Exception e) {
			// This should throw an error...
		}
	}

}
