package c10quality.text.temperature;

import java.util.InputMismatchException;
import java.util.Scanner;

/**
 * This version of the temperature controller handles thrown exceptions.
 * 
 * @author kvlinden
 * @version Spring, 2012
 */
public class TemperatureConsole {

	public static void main(String[] args) {

		// Temperature temperature1 = null;
		// try {
		// temperature1 = new Temperature(98.6, 'f');
		// System.out.println(temperature1.getDegrees());
		// } catch (Exception e) {
		// System.out.println(e.getMessage());
		// }
		//
		// try {
		// Temperature temperature2 = new Temperature(98.6, 'x');
		// System.out.println(temperature2.getDegrees());
		// } catch (Exception e) {
		// System.out.println(e.getMessage());
		// }

		// Temperature temperature;
		// try {
		// temperature = new Temperature(-1.0, 'K');
		// System.out.println(temperature.getDegrees());
		// } catch (Exception e) {
		// System.out.println(e.getMessage());
		// }

		// try {
		// temperature1.change(-1000.0);
		// System.out.println("We should never get here!");
		// } catch (Exception e) {
		// System.out.println(e.getMessage());
		// }
		//
		// try {
		// temperature1.setScale('X');
		// System.out.println("We should never get here!");
		// } catch (Exception e) {
		// System.out.println(e.getMessage());
		// }

		Temperature temperature;
		Scanner scanner = new Scanner(System.in);
		System.out.print("Please enter a temperature: ");
		try {
			temperature = new Temperature(scanner.nextDouble(), scanner.next().charAt(0));
			System.out.println("You entered: " + temperature);
		} catch (InputMismatchException e) {
			System.out.println("Please enter a valid degree value.");
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}

	}
}
