package c10quality.text.temperature;

import java.util.InputMismatchException;
import java.util.Scanner;

import c10quality.text.temperatureGUI.Temperature1;

/**
 * TemperatureConverterConsole implements a simple text-based interface for the
 * temperature converter application.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class TemperatureConverterConsole {

	public static void main(String[] args) {
		System.out.print("Enter a temperature (e.g., 98.6 F): ");
		// System.out.print("Enter a temperature: ");

		Scanner keyboard = new Scanner(System.in);
		try {
			double degrees = keyboard.nextDouble();
			char scale = keyboard.next().charAt(0);
			Temperature temperature = new Temperature(degrees, scale);
			System.out.print("Convert to: ");
			temperature.setScale(keyboard.next().charAt(0));
			System.out.println("Result: " + temperature);
		} catch (InputMismatchException e) {
			System.out.println("Please enter a valid degree value of the form 98.6 F.");
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}

	}

}
