/**
 * Simple phoneDialer application
 * @author snelesen
 * @version Fall 2011
 */

package c11ui.lecture.phoneDialer;

import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import java.awt.BorderLayout;
import java.awt.GridLayout;

public class PhoneDialer2 extends JFrame implements ActionListener{

	private JButton[] numbers;
	private JButton phone;
	private JTextField dialed;
	//Keeps track of whether a valid number has been entered to dial
	private boolean clearScreen;
	
	// Construct each piece, including an array for the number buttons
	public PhoneDialer2(){
		clearScreen = true;
		setTitle("Phone Dialer");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		dialed  = new JTextField("Number dialed will appear here");
		add(dialed, BorderLayout.NORTH);
	
		//Keep numbers on a panel so the layout will be correct if resized
		JPanel keypad = new JPanel();
		keypad.setLayout(new GridLayout(4,3));
		
		numbers = new JButton[12];
		for (int i=1; i<=9; i++){
			numbers[i] = new JButton("" + i);
			numbers[i].addActionListener(this);
			keypad.add(numbers[i]);
		}
		//Leave a blank space in grid so zero is centered at bottom
		keypad.add(new JLabel(""));
		// Put 0 in 0th place of array, so our logic doesn't get complicated
		numbers[0]= new JButton("0");
		numbers[0].addActionListener(this);
		keypad.add(numbers[0]);
		//Stick panel on the frame
		add(keypad, BorderLayout.CENTER);
		
		phone = new JButton("Phone");
		phone.addActionListener(this);
		add(phone, BorderLayout.SOUTH);
	}
	
	public void actionPerformed(ActionEvent e){
		//If user hit the phone button, check if we have a valid number
		if (e.getActionCommand().equals("Phone")){
			if (clearScreen){
				dialed.setText("Enter a valid number");
			}
			// if valid, tell them we're dialing
			else{
				dialed.setText("Dialing..." + dialed.getText());
				clearScreen = true;
			}
		}
		
		// If they hit a number, add it to the textfield
		for (int i = 0; i<= 9; i++){
			if (e.getActionCommand().equals(Integer.toString(i))){
				//if its the first number, clear out the prompt
				if (clearScreen){
					dialed.setText(Integer.toString(i));
					clearScreen = false;
				}
				// Otherwise append
				else{
					dialed.setText(dialed.getText()+i);
				}
			}
		}
	}
	
	public static void main(String[] args) {
		PhoneDialer2 dialer = new PhoneDialer2();	
		dialer.pack();
		dialer.setVisible(true);
	}

}

	