package c11ui.lecture.rain;

import processing.core.PApplet;

public class RainPanel extends PApplet {
	
	private static final int DROP_COUNT = 1000, DROP_DIAMETER = 10, DROP_VELOCITY = 5;

	private Drop[] drops;
	private double phaseIn;  // Allows program to add drop objects one at a time
	private int width = 400, height = 600;
	
	public RainPanel(){
		drops = new Drop[DROP_COUNT];
		  phaseIn = 0.0;
		  for (int i = 0; i < drops.length; i++) {
			    drops[i] = new Drop(random(DROP_DIAMETER, width - DROP_DIAMETER), DROP_DIAMETER, DROP_DIAMETER, DROP_VELOCITY);
			  }
	}
	
	public void setup() {
	  size(width, height);
	  background(255);
	  smooth();
	  
	}

	public void draw() {
	  background(255);
	  for (int i = 0; i < drops.length && i < phaseIn; i++) {
	    drops[i].move();
	    drops[i].display(this, height);
	    // Check for collosions with other drops.
	    for (int j = 0; j < drops.length && j < phaseIn; j++) {
	      if (i != j) {
	        drops[i].combine(drops[j]);
	      }
	    }
	  }
	  phaseIn += 0.5;
	}

	
}
