package c11ui.lecture.scribbler;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class DrawerController extends JFrame implements ActionListener {

	public static final int DEFAULT_STROKE_WEIGHT = 1;
	public DrawerPanel drawerPanel;
	public JTextField strokeWeightField;
	public JButton randomColorButton, blackButton, whiteButton;

	public DrawerController() {
		setTitle("Drawer");
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		drawerPanel = new DrawerPanel(DEFAULT_STROKE_WEIGHT);
		drawerPanel.init();
		add(drawerPanel, BorderLayout.NORTH);

		JPanel controlPanel = new JPanel();
		controlPanel.setLayout(new FlowLayout());
		controlPanel.add(new JLabel("Weight:"));
		strokeWeightField = new JTextField(3);
		strokeWeightField.setText(Integer.toString(DEFAULT_STROKE_WEIGHT));
		strokeWeightField.addActionListener(this);
		controlPanel.add(strokeWeightField, BorderLayout.SOUTH);
		randomColorButton = new JButton("random");
		randomColorButton.addActionListener(this);
		controlPanel.add(randomColorButton);
		blackButton = new JButton("black");
		blackButton.addActionListener(this);
		//controlPanel.add(blackButton);
		whiteButton = new JButton("white");
		whiteButton.addActionListener(this);
		//controlPanel.add(whiteButton);
		add(controlPanel, BorderLayout.SOUTH);
	}

	public static void main(String[] args) {
		DrawerController controller = new DrawerController();
		controller.pack();
		controller.setVisible(true);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equals("black")) {
			drawerPanel.setBlack();
		} else if (e.getActionCommand().equals("white")) {
			drawerPanel.setWhite();
		} else if (e.getActionCommand().equals("random")) {
			drawerPanel.setRandom();
		}
		int strokeWeight = Integer.parseInt(strokeWeightField.getText());
		drawerPanel.setStrokeWeight(strokeWeight);
	}

}
