package c11ui.lecture.shaker.shaker2;

import processing.core.PApplet;

/**
 * ShakerPanel is an upgraded Java encapsulation of the original shaking circle
 * application. It allows the controller to change the shift rate.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class ShakerPanel extends PApplet {

	private static final int SIZE = 300;
	private int myX, myY, myShift;

	public ShakerPanel() {
		myX = myY = SIZE / 2;
		myShift = 5;
	}

        public int getShift() {
	    return myShift;
	}

        public void setShift(int shift) throws Exception {
		if (shift < 0) {
			throw new Exception("invalid shift value: " + shift);
		}
		myShift = shift;
	}

	public void setup() {
		size(SIZE, SIZE);
		smooth();
	}

	public void draw() {
		background(255);
		strokeWeight(2);
		ellipse(myX + random(-myShift / 2, myShift / 2), myY + random(-myShift / 2, myShift / 2),
				50, 50);
	}

	public void mousePressed() {
		myX = mouseX;
		myY = mouseY;
	}
}
