package c11ui.lecture.shaker.shaker4;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * ShakerController4 is a upgraded version of a Java controller for the Processing
 * raindrops application. It provides a shift slide controller.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class ShakerController extends JFrame implements ChangeListener {

	public static final int DEFAULT_SIZE = 300, INITIAL_SHIFT = 5;
	
	private ShakerPanel shakerPanel;
	private JTextField shiftField;
	private JButton startButton, pauseButton;

	public ShakerController() {
		setTitle("Shaker4");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		
		shakerPanel = new ShakerPanel(DEFAULT_SIZE, INITIAL_SHIFT);
		shakerPanel.init();
		add(shakerPanel, BorderLayout.NORTH);

		// The slider interface
		JPanel controller = new JPanel();
		controller.setLayout(new FlowLayout());
		controller.add(new JLabel("Shift factor: "));
		JSlider slider = new JSlider(JSlider.HORIZONTAL, 0, DEFAULT_SIZE, INITIAL_SHIFT);
		slider.setMajorTickSpacing(50);
		slider.setPaintTicks(true);
		slider.setPaintLabels(true);
		slider.addChangeListener(this);
		controller.add(slider);
		add(controller, BorderLayout.CENTER);
	}
	
	@Override
	public void stateChanged(ChangeEvent e) {
		JSlider slider = (JSlider) e.getSource();
		int value = slider.getValue();
		shakerPanel.setShift(value);
	}

	public static void main(String[] args) {
		ShakerController controller = new ShakerController();
		controller.pack();
		controller.setVisible(true);
	}

}
