package c11ui.lecture.shaker.shaker4;

import processing.core.PApplet;

/**
 * ShakerPanel4 is an upgraded Java encapsulation of the original shaking circle
 * application. It allows the controller to change the shift rate and to set the
 * initial output panel size.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class ShakerPanel extends PApplet {

	private int mySize, myX, myY, myShift;
	private boolean myRunningStatus;

	public ShakerPanel(int size, int shift) {
		mySize = size;
		myX = myY = mySize / 2;
		myShift = shift;
		myRunningStatus = true;
	}

	public void setShift(int shift) {
		if (shift < 0) {
			System.out.println("invalid shift value: " + shift);
			exit();
		}
		myShift = shift;
	}

	public void setRunning(boolean status) {
		myRunningStatus = status;
	}

	public void setup() {
		size(mySize, mySize);
		smooth();
	}

	public void draw() {
		if (myRunningStatus) {
			background(255);
			strokeWeight(2);
			ellipse(myX + random(-myShift / 2, myShift / 2), myY
					+ random(-myShift / 2, myShift / 2), 50, 50);
		}
	}

	public void mousePressed() {
		myX = mouseX;
		myY = mouseY;
	}
}
