package c11ui.text.raindrops.raindrops2;

import processing.core.PApplet;

/**
 * RaindropPanel is an enhanced Java encapsulation of the original raindrops
 * animation from Processing. It provides start/pause capability.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class RaindropPanel extends PApplet {

	private static final int SIZE = 300;
	
	private int myFrameRate, myDiameter;
	private boolean myRunningStatus;

	// private enum Status {
	// RUNNING, STOPPED
	// };
	// private Status myStatus;

	public RaindropPanel() {
		myFrameRate = 30;
		myRunningStatus = true;
	}

	public RaindropPanel(int initialFrameRate) throws Exception {
		setFrameRate(initialFrameRate);
		myRunningStatus = true;
	}

	public void setFrameRate(int frameRate) throws Exception {
		if (frameRate < 1) {
			throw new Exception("Bad framerate: " + frameRate);
		}
		myFrameRate = frameRate;
		// if (frameRate < 0) {
		// throw new IllegalArgumentException("Bad framerate: " + frameRate);
		// }
		// if (frameRate == 0) {
		// myStatus = Status.STOPPED;
		// } else {
		// myStatus = Status.RUNNING;
		// myFrameRate = frameRate;
		// }
	}

	public void setRunning(boolean running) {
		myRunningStatus = running;
	}

	public void setup() {
		size(SIZE, SIZE);
	}

	public void draw() {
		if (myRunningStatus) {
			frameRate(myFrameRate);
			fill(random(255), random(255), random(255), random(255));
			myDiameter = (int) random(SIZE / 2);
			ellipse(random(SIZE), random(SIZE), myDiameter, myDiameter);
		}
	}

	public void mousePressed() {
		background(200);
	}

}
