package c11ui.text.raindrops.raindrops4;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import c11ui.text.raindrops.raindrops3.RaindropPanel;

/**
 * RaindropsController4 shows the original raindrops animation at various speeds
 * using a slider control.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
@SuppressWarnings("serial")
public class RaindropController extends JFrame implements ChangeListener {

	private final static int INITIAL_FRAME_RATE = 20;

	private JTextField frameRateField;
	private RaindropPanel raindropPanel;

	public RaindropController() {
		setTitle("Raindrops");
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		raindropPanel = new RaindropPanel(INITIAL_FRAME_RATE);
		raindropPanel.init();
		add(raindropPanel, BorderLayout.NORTH);

		JPanel controller = new JPanel();
		controller.setLayout(new FlowLayout());

		// The slider interface
		controller.add(new JLabel("FrameRate: "));
		JSlider slider = new JSlider(JSlider.HORIZONTAL, 1, 61,
				INITIAL_FRAME_RATE);
		slider.setMajorTickSpacing(10);
		slider.setPaintTicks(true);
		slider.setPaintLabels(true);
		slider.addChangeListener(this);
		controller.add(slider);
		add(controller, BorderLayout.CENTER);
	}

	@Override
	public void stateChanged(ChangeEvent e) {
		JSlider slider = (JSlider) e.getSource();
		int value = slider.getValue();
		raindropPanel.setFrameRate(value);
	}

	public static void main(String[] args) {
		RaindropController controller = new RaindropController();
		controller.pack();
		controller.setVisible(true);
		controller.setLocation(100, 100);
	}

}
