package c11ui.text.tipCalculator;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

@SuppressWarnings("serial")
public class TipCalculatorGUI2 extends JFrame implements ActionListener {

	private static final double TIP_RATE = 0.15;

	private JTextField billField, tipField, outputField;

	public TipCalculatorGUI2() {
		setTitle("Tip Calculator");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new BorderLayout());

		// The input panel
		JPanel controlPanel = new JPanel(new FlowLayout());
		controlPanel.add(new JLabel("bill:"));
		billField = new JTextField(10);
		controlPanel.add(billField);
		billField.addActionListener(this);

		controlPanel.add(new JLabel("suggested tip:"));
		tipField = new JTextField(10);
		controlPanel.add(tipField);
		add(controlPanel, BorderLayout.CENTER);

		// The output message panel
		outputField = new JTextField("Please enter a total bill in the bill field.");
		outputField.setEditable(false);
		add(outputField, BorderLayout.SOUTH);
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		String billFieldString = billField.getText();
		try {
			double bill = Double.parseDouble(billFieldString);
			double tip = bill * TIP_RATE;
			String tipString = new DecimalFormat("$0.00").format(tip);
			tipField.setText(tipString);
		} catch (Exception e) {
			outputField.setText("illegal bill value: " + "\"" + billFieldString + "\"");
		}
	}

	public static void main(String[] args) {
		TipCalculatorGUI2 controller = new TipCalculatorGUI2();
		controller.pack();
		controller.setVisible(true);
	}

}
