package c11ui.text.tipCalculator;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

@SuppressWarnings("serial")
public class TipCalculatorGUI3 extends JFrame {

	private static final double TIP_RATE = 0.15;

	private JTextField billField, tipField, outputField;
	private JButton clearButton;

	public TipCalculatorGUI3() {
		setTitle("Tip Calculator");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new BorderLayout());

		// The input panel
		JPanel controlPanel = new JPanel(new FlowLayout());
		controlPanel.add(new JLabel("bill:"));
		billField = new JTextField(10);
		controlPanel.add(billField);
		billField.addActionListener(new BillFieldListener());

		controlPanel.add(new JLabel("suggested tip:"));
		tipField = new JTextField(10);
		controlPanel.add(tipField);

		clearButton = new JButton("Clear");
		clearButton.addActionListener(new ClearButtonListener());
		controlPanel.add(clearButton);

		add(controlPanel, BorderLayout.CENTER);

		// The output message panel
		outputField = new JTextField("Please enter a total bill in the bill field.");
		outputField.setEditable(false);
		add(outputField, BorderLayout.SOUTH);
	}

	class BillFieldListener implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent ae) {
			String billFieldString = billField.getText();
			try {
				double bill = Double.parseDouble(billFieldString);
				double tip = bill * TIP_RATE;
				String tipString = new DecimalFormat("$0.00").format(tip);
				tipField.setText(tipString);
			} catch (Exception e) {
				outputField.setText("illegal bill value: " + "\"" + billFieldString + "\"");
			}
		}
	}

	class ClearButtonListener implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent ae) {
			billField.setText("");
			tipField.setText("");
			outputField.setText("");
		}
	}

	public static void main(String[] args) {
		TipCalculatorGUI3 controller = new TipCalculatorGUI3();
		controller.pack();
		controller.setVisible(true);
	}

}
