package c12lists.lecture.countryguess;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * CountryGuessController0 implements a country guessing game with a single,
 * hard-coded country name.
 * 
 * @author kvlinden, snelesen
 * @version Fall, 2009
 * @version Spring 2012: Refactored to use inner classes for action listeners
 */
@SuppressWarnings("serial")
public class CountryGuessController0 extends JFrame {

	private JLabel hintLabel;
	private JTextField guessField;
	private JButton guessButton, giveupButton;

	public CountryGuessController0() {
		setTitle("Country Guess");
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		Font font = new Font("Ariel", 0, 18);

		hintLabel = new JLabel();
		hintLabel.setFont(font);
		hintLabel.setText("Please guess a country");
		add(hintLabel, BorderLayout.CENTER);

		JPanel guessController = new JPanel();
		guessController.setLayout(new FlowLayout());
		JLabel guessLabel = new JLabel("Guess: ");
		guessLabel.setFont(font);
		guessController.add(guessLabel);
		guessField = new JTextField(15);
		guessField.setFont(font);
		guessField.addActionListener(new GuessListener());
		guessController.add(guessField);
		guessButton = new JButton("Guess");
		guessButton.setFont(font);
		guessButton.addActionListener(new GuessListener());
		guessController.add(guessButton);
		giveupButton = new JButton("Give Up");
		giveupButton.setFont(font);
		giveupButton.addActionListener(new GiveUpListener());
		guessController.add(giveupButton);
		add(guessController, BorderLayout.SOUTH);

	}

	private class GuessListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (guessField.getText().equalsIgnoreCase("Australia")) {
				hintLabel.setText("You got it!");
			} else {
				hintLabel.setText("Try again.");
			}
			guessField.setText("");
		}
	}

	private class GiveUpListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			hintLabel.setText("Quitter...");
			guessField.setText("");
		}
	}

	
	public static void main(String[] args) {
		CountryGuessController0 application = new CountryGuessController0();
		application.pack();
		application.setVisible(true);
	}

}
