package c12lists.lecture.countryguess;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * CountryGuessController implements a simple country guessing game.
 * 
 * @author kvlinden, snelesen
 * @version Fall, 2009
 * @version Spring 2012: Refactored to use inner classes for action listeners
 */
@SuppressWarnings("serial")
public class CountryGuessController1 extends JFrame  {

	private JLabel hintLabel;
	private JTextField guessField;
	private JButton guessButton, giveupButton;
	private CountryGuessGame0 countryGuessGame;

	public CountryGuessController1() {
		setTitle("Country Guess");
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		Font font = new Font("Ariel", 0, 18);

		hintLabel = new JLabel();
		hintLabel.setFont(font);
		add(hintLabel, BorderLayout.CENTER);

		JPanel guessController = new JPanel();
		guessController.setLayout(new FlowLayout());
		JLabel guessLabel = new JLabel("Guess: ");
		guessLabel.setFont(font);
		guessController.add(guessLabel);
		guessField = new JTextField(15);
		guessField.setFont(font);
		guessField.setActionCommand("Guess");
		guessField.addActionListener(new GuessListener());
		guessController.add(guessField);
		guessButton = new JButton("Guess");
		guessButton.setFont(font);
		guessButton.addActionListener(new GuessListener());
		guessController.add(guessButton);
		giveupButton = new JButton("Give Up");
		giveupButton.setFont(font);
		giveupButton.addActionListener(new GiveUpListener());
		guessController.add(giveupButton);
		add(guessController, BorderLayout.SOUTH);

		countryGuessGame = new CountryGuessGame0();
		hintLabel.setText("Please guess a country -" + countryGuessGame.getHintText());
	}

	private class GuessListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (countryGuessGame.guess(guessField.getText())) {
				countryGuessGame.reset();
				hintLabel.setText("Right! Next: " + countryGuessGame.getHintText());
			} else {
				hintLabel.setText("guess again - " + countryGuessGame.getHintText());
			}
			guessField.setText("");
		}
	}

	private class GiveUpListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			String answer = countryGuessGame.getAnswer();
			countryGuessGame.reset();
			hintLabel.setText("Answer: " + answer + " - Next: " + countryGuessGame.getHintText());
			guessField.setText("");
		}
	}

	public static void main(String[] args) {
		CountryGuessController1 application = new CountryGuessController1();
		application.pack();
		application.setVisible(true);
	}

}
