package c12lists.lecture.countryguess;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class CountryGuessGame2 {

	private List<Country> myCountries;
	private int myAnswerIndex, myHintCount;

	private Random myRandom;

	public CountryGuessGame2() {
		myCountries = loadCountries();
		myRandom = new Random();
		reset();
	}

	public CountryGuessGame2(int answerIndex) {
		myCountries = loadCountries();
		myAnswerIndex = answerIndex;
		myHintCount = 0;
	}

	public void reset() {
		myAnswerIndex = myRandom.nextInt(myCountries.size());
		myHintCount = 0;
	}

	public boolean guess(String text) {
		return myCountries.get(myAnswerIndex).getName().equalsIgnoreCase(text);
	}

	public String getAnswer() {
		return myCountries.get(myAnswerIndex).getName();
	}

	public String getHintText() {
		myHintCount++;
		String name = myCountries.get(myAnswerIndex).getName();
		if (myHintCount == 1) {
			return "The country is in " + myCountries.get(myAnswerIndex).getContinentName();
		} else if (myHintCount == 2) {
			return "The name starts with '" + name.charAt(0) + "'";
		} else if (myHintCount == 3) {
			return "The name has " + name.length() + " letters";
		} else if (myHintCount == 4) {
			return "The name ends with '" + name.charAt(name.length() - 1) + "'";
		} else {
			return "no more hints";
		}
	}

	// public String getHintImage() {
	// switch (myHintCount) {
	// case 0:
	// return "blank.jpg";
	// case 1:
	// return myCountries.get(myAnswerIndex).getImageName();
	// default:
	// return "no more hints";
	// }
	// }

	private List<Country> loadCountries() {
		List<Country> result = new ArrayList<Country>();
		result.add(new Country("Algeria", "Africa"));
		result.add(new Country("Angola", "Africa"));
		result.add(new Country("Bassas da India", "Asia"));
		result.add(new Country("Benin", "Africa"));
		result.add(new Country("Botswana", "Africa"));
		result.add(new Country("Bouvet Island", "Africa"));
		result.add(new Country("Burkina Faso", "Africa"));
		result.add(new Country("Burundi", "Africa"));
		result.add(new Country("Cameroon", "Africa"));
		result.add(new Country("Cape Verde", "Africa"));
		result.add(new Country("Central African Republic", "Africa"));
		result.add(new Country("Chad", "Africa", "Chad.jpg"));
		result.add(new Country("Comoros", "Africa", "Comoros.jpg"));
		result.add(new Country("Congo", "Africa", "Congo.jpg"));
		result.add(new Country("Congo, Republic of the", "Africa"));
		result.add(new Country("Cote d'Ivoire", "Africa"));
		result.add(new Country("Djibouti", "Africa"));
		result.add(new Country("Egypt", "Africa"));
		result.add(new Country("Equatorial Guinea", "Africa"));
		result.add(new Country("Eritrea", "Africa"));
		result.add(new Country("Ethiopia", "Africa"));
		result.add(new Country("Europa Island", "Africa"));
		result.add(new Country("Gabon", "Africa"));
		result.add(new Country("Gambia", "Africa"));
		result.add(new Country("Ghana", "Africa"));
		result.add(new Country("Glorioso Islands", "Africa"));
		result.add(new Country("Guinea", "Africa"));
		result.add(new Country("Guinea-Bissau", "Africa"));
		result.add(new Country("Juan de Nova Island", "Africa"));
		result.add(new Country("Kenya", "Africa"));
		result.add(new Country("Lesotho", "Africa"));
		result.add(new Country("Liberia", "Africa"));
		result.add(new Country("Libya", "Africa"));
		result.add(new Country("Madagascar", "Africa"));
		result.add(new Country("Malawi", "Africa"));
		result.add(new Country("Mali", "Africa"));
		result.add(new Country("Mauritania", "Africa"));
		result.add(new Country("Mauritius", "Africa"));
		result.add(new Country("Mayotte", "Africa"));
		result.add(new Country("Morocco", "Africa"));
		result.add(new Country("Mozambique", "Africa"));
		result.add(new Country("Namibia", "Africa"));
		result.add(new Country("Niger", "Africa"));
		result.add(new Country("Nigeria", "Africa"));
		result.add(new Country("Reunion", "Africa"));
		result.add(new Country("Rwanda", "Africa"));
		result.add(new Country("Saint Helena", "Africa"));
		result.add(new Country("Sao Tome and Principe", "Africa"));
		result.add(new Country("Senegal", "Africa"));
		result.add(new Country("Seychelles", "Africa"));
		result.add(new Country("Sierra Leone", "Africa"));
		result.add(new Country("Somalia", "Africa"));
		result.add(new Country("South Africa", "Africa"));
		result.add(new Country("Sudan", "Africa"));
		result.add(new Country("Swaziland", "Africa"));
		result.add(new Country("Tanzania", "Africa"));
		result.add(new Country("Togo", "Africa"));
		result.add(new Country("Tunisia", "Africa"));
		result.add(new Country("Uganda", "Africa"));
		result.add(new Country("Western Sahara", "Africa"));
		result.add(new Country("Zimbabwe", "Africa"));
		result.add(new Country("Zambia", "Africa"));
		result.add(new Country("Afghanistan", "Asia"));
		result.add(new Country("Armenia", "Asia"));
		result.add(new Country("Ashmore and Cartier Islands", "Asia"));
		result.add(new Country("Azerbaijan", "Asia"));
		result.add(new Country("Bangladesh", "Asia"));
		result.add(new Country("Bhutan", "Asia"));
		result.add(new Country("British Indian Ocean Territory", "Asia"));
		result.add(new Country("Brunei", "Asia"));
		result.add(new Country("Cambodia", "Asia"));
		result.add(new Country("China", "Asia"));
		result.add(new Country("Christmas Island", "Asia"));
		result.add(new Country("Cocos Islands", "Asia"));
		result.add(new Country("East Timor", "Asia"));
		result.add(new Country("Georgia", "Asia"));
		result.add(new Country("Hong Kong", "Asia"));
		result.add(new Country("India", "Asia"));
		result.add(new Country("Indonesia", "Asia"));
		result.add(new Country("Japan", "Asia"));
		result.add(new Country("Kazakhstan", "Asia"));
		result.add(new Country("South Korea", "Asia"));
		result.add(new Country("South Korea", "Asia"));
		result.add(new Country("Kyrgyzstan", "Asia"));
		result.add(new Country("Laos", "Asia"));
		result.add(new Country("Macau", "Asia"));
		result.add(new Country("Malaysia", "Asia"));
		result.add(new Country("Maldives", "Asia"));
		result.add(new Country("Mongolia", "Asia"));
		result.add(new Country("Burma", "Asia"));
		result.add(new Country("Nepal", "Asia"));
		result.add(new Country("Pakistan", "Asia"));
		result.add(new Country("Paracel Islands", "Asia"));
		result.add(new Country("Philippines", "Asia"));
		result.add(new Country("Singapore", "Asia"));
		result.add(new Country("Spratly Islands", "Asia"));
		result.add(new Country("Sri Lanka", "Asia"));
		result.add(new Country("Taiwan", "Asia"));
		result.add(new Country("Tajikistan", "Asia"));
		result.add(new Country("Thailand", "Asia"));
		result.add(new Country("Turkmenistan", "Asia"));
		result.add(new Country("Uzbekistan", "Asia"));
		result.add(new Country("Vietnam", "Asia"));
		result.add(new Country("Anguilla", "the Caribbean"));
		result.add(new Country("Antigua and Barbuda", "the Caribbean"));
		result.add(new Country("Aruba", "the Caribbean"));
		result.add(new Country("Bahamas", "the Caribbean"));
		result.add(new Country("Barbados", "the Caribbean"));
		result.add(new Country("British Virgin Islands", "the Caribbean"));
		result.add(new Country("Cuba", "the Caribbean"));
		result.add(new Country("Cayman Islands", "the Caribbean"));
		result.add(new Country("Dominica", "the Caribbean"));
		result.add(new Country("Dominican Republic", "the Caribbean"));
		result.add(new Country("Grenada", "the Caribbean"));
		result.add(new Country("Guadeloupe", "the Caribbean"));
		result.add(new Country("Haiti", "the Caribbean"));
		result.add(new Country("Jamaica", "the Caribbean"));
		result.add(new Country("Martinique", "the Caribbean"));
		result.add(new Country("Montserrat", "the Caribbean"));
		result.add(new Country("Navassa Island", "the Caribbean"));
		result.add(new Country("Netherlands Antilles", "the Caribbean"));
		result.add(new Country("Puerto Rico", "the Caribbean"));
		result.add(new Country("Saint Kitts and Nevis", "the Caribbean"));
		result.add(new Country("Saint Lucia", "the Caribbean"));
		result.add(new Country("Saint Vincent and the Grenadines", "the Caribbean"));
		result.add(new Country("Trinidad and Tobago", "the Caribbean"));
		result.add(new Country("Turks and Caicos Islands", "the Caribbean"));
		result.add(new Country("Virgin Islands", "the Caribbean"));
		result.add(new Country("Belize", "Central America"));
		result.add(new Country("Costa Rica", "Central America"));
		result.add(new Country("Clipperton Island", "Central America"));
		result.add(new Country("El Salvador", "Central America"));
		result.add(new Country("Guatemala", "Central America"));
		result.add(new Country("Honduras", "Central America"));
		result.add(new Country("Nicaragua", "Central America"));
		result.add(new Country("Panama", "Central America"));
		result.add(new Country("Albania", "Europe"));
		result.add(new Country("Andorra", "Europe"));
		result.add(new Country("Austria", "Europe"));
		result.add(new Country("Belarus", "Europe"));
		result.add(new Country("Belgium", "Europe"));
		result.add(new Country("Bosnia and Herzegovina", "Europe"));
		result.add(new Country("Bulgaria", "Europe"));
		result.add(new Country("Croatia", "Europe"));
		result.add(new Country("Czech Republic", "Europe"));
		result.add(new Country("Denmark", "Europe"));
		result.add(new Country("Estonia", "Europe"));
		result.add(new Country("Faroe Islands", "Europe"));
		result.add(new Country("Finland", "Europe"));
		result.add(new Country("France", "Europe"));
		result.add(new Country("Germany", "Europe"));
		result.add(new Country("Gibraltar", "Europe"));
		result.add(new Country("Greece", "Europe"));
		result.add(new Country("Guernsey", "Europe"));
		result.add(new Country("Vatican City", "Europe"));
		result.add(new Country("Hungary", "Europe"));
		result.add(new Country("Iceland", "Europe"));
		result.add(new Country("Ireland", "Europe"));
		result.add(new Country("Italy", "Europe"));
		result.add(new Country("Jan Mayen", "Europe"));
		result.add(new Country("Jersey", "Europe"));
		result.add(new Country("Latvia", "Europe"));
		result.add(new Country("Liechtenstein", "Europe"));
		result.add(new Country("Lithuania", "Europe"));
		result.add(new Country("Luxembourg", "Europe"));
		result.add(new Country("Macedonia", "Europe"));
		result.add(new Country("Malta", "Europe"));
		result.add(new Country("Man, Isle of", "Europe"));
		result.add(new Country("Moldova", "Europe"));
		result.add(new Country("Monaco", "Europe"));
		result.add(new Country("Netherlands", "Europe"));
		result.add(new Country("Norway", "Europe"));
		result.add(new Country("Poland", "Europe"));
		result.add(new Country("Portugal", "Europe"));
		result.add(new Country("Romania", "Europe"));
		result.add(new Country("Russia", "Europe"));
		result.add(new Country("San Marino", "Europe"));
		result.add(new Country("Serbia and Montenegro", "Europe"));
		result.add(new Country("Slovakia", "Europe"));
		result.add(new Country("Slovenia", "Europe"));
		result.add(new Country("Spain", "Europe"));
		result.add(new Country("Svalbard", "Europe"));
		result.add(new Country("Sweden", "Europe"));
		result.add(new Country("Switzerland", "Europe"));
		result.add(new Country("Ukraine", "Europe"));
		result.add(new Country("United Kingdom", "Europe"));
		result.add(new Country("Bahrain", "the Middle East"));
		result.add(new Country("Cyprus", "the Middle East"));
		result.add(new Country("Iran", "the Middle East"));
		result.add(new Country("Iraq", "the Middle East"));
		result.add(new Country("Israel", "the Middle East"));
		result.add(new Country("Jordan", "the Middle East"));
		result.add(new Country("Kuwait", "the Middle East"));
		result.add(new Country("Lebanon", "the Middle East"));
		result.add(new Country("Oman", "the Middle East"));
		result.add(new Country("Qatar", "the Middle East"));
		result.add(new Country("Saudi Arabia", "the Middle East"));
		result.add(new Country("Syria", "the Middle East"));
		result.add(new Country("Turkey", "the Middle East"));
		result.add(new Country("United Arab Emirates", "the Middle East"));
		result.add(new Country("West Bank", "the Middle East"));
		result.add(new Country("Yemen", "the Middle East"));
		result.add(new Country("Bermuda", "North America"));
		result.add(new Country("Canada", "North America"));
		result.add(new Country("Greenland", "North America"));
		result.add(new Country("Mexico", "North America"));
		result.add(new Country("Saint Pierre and Miquelon", "North America"));
		result.add(new Country("United States", "North America"));
		result.add(new Country("American Samoa", "the the Pacific"));
		result.add(new Country("Australia", "the Pacific"));
		result.add(new Country("Baker Island", "the Pacific"));
		result.add(new Country("Cook Islands", "the Pacific"));
		result.add(new Country("Coral Sea Islands", "the Pacific"));
		result.add(new Country("Fiji", "the Pacific"));
		result.add(new Country("French Polynesia", "the Pacific"));
		result.add(new Country("Guam", "the Pacific"));
		result.add(new Country("Heard Island and McDonald Islands", "the Pacific"));
		result.add(new Country("Howland Island", "the Pacific"));
		result.add(new Country("Jarvis Island", "the Pacific"));
		result.add(new Country("Johnston Atoll", "the Pacific"));
		result.add(new Country("Kingman Reef", "the Pacific"));
		result.add(new Country("Kiribati", "the Pacific"));
		result.add(new Country("Marshall Islands", "the Pacific"));
		result.add(new Country("Micronesia, Federated States of", "the Pacific"));
		result.add(new Country("Midway Islands", "the Pacific"));
		result.add(new Country("Nauru", "the Pacific"));
		result.add(new Country("New Caledonia", "the Pacific"));
		result.add(new Country("New Zealand", "the Pacific"));
		result.add(new Country("Niue", "the Pacific"));
		result.add(new Country("Norfolk Island", "the Pacific"));
		result.add(new Country("Northern Mariana Islands", "the Pacific"));
		result.add(new Country("Palau", "the Pacific"));
		result.add(new Country("Palmyra Atoll", "the Pacific"));
		result.add(new Country("Papua New Guinea", "the Pacific"));
		result.add(new Country("Pitcairn Islands", "the Pacific"));
		result.add(new Country("Samoa", "the Pacific"));
		result.add(new Country("Solomon Islands", "the Pacific"));
		result.add(new Country("Tokelau", "the Pacific"));
		result.add(new Country("Tonga", "the Pacific"));
		result.add(new Country("Tuvalu", "the Pacific"));
		result.add(new Country("Vanuatu", "the Pacific"));
		result.add(new Country("Wake Island", "the Pacific"));
		result.add(new Country("Wallis and Futuna", "the Pacific"));
		result.add(new Country("Argentina", "South America"));
		result.add(new Country("Bolivia", "South America"));
		result.add(new Country("Brazil", "South America"));
		result.add(new Country("Chile", "South America"));
		result.add(new Country("Colombia", "South America"));
		result.add(new Country("Ecuador", "South America"));
		result.add(new Country("Falkland Islands", "South America"));
		result.add(new Country("French Guiana", "South America"));
		result.add(new Country("Guyana", "South America"));
		result.add(new Country("Paraguay", "South America"));
		result.add(new Country("Peru", "South America"));
		result.add(new Country("South Georgia and the South Sandwich Islands", "South America"));
		result.add(new Country("Suriname", "South America"));
		result.add(new Country("Uruguay", "South America"));
		result.add(new Country("Venezuela", "South America"));
		return result;
	}

}
