package c12lists.lecture.examples;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class ReadNumbersConsole {
	
	public static final String PATH = "src/c11files/examples/data/"; 

	public static double computeAverage(List<Integer> values) {
		int sum = 0;
		for (int i = 0; i < values.size(); i++) {
			sum += values.get(i);
		}
		return sum / values.size();
	}

	public static double computeVariance(List<Integer> values, double average) {
		int sum = 0;
		for (int i = 0; i < values.size(); i++) {
			sum += Math.pow(values.get(i) - average, 2);
		}
		return Math.sqrt(sum / values.size());
	}

	public static void main(String[] args) {
		Scanner keyboard = new Scanner(System.in);
		System.out.print("Data filename: ");
		String filename = keyboard.next();
		try{
			Scanner fileIn = new Scanner(new File(PATH, filename));
			List<Integer> scores = new ArrayList<Integer>();
			for ( ; fileIn.hasNext(); ) {
				scores.add(fileIn.nextInt());
			}
			fileIn.close();
			System.out.println(scores);

			double average = computeAverage(scores);
			System.out.printf("average: %5.2f%n", average);
			System.out.printf("std dev: %5.2f%n", computeVariance(scores, average));
		}
		catch(FileNotFoundException e){
			System.out.println("Invalid file indicated.");
		}

	}

}
