package c12lists.text.Gateway;

import java.util.ArrayList;
import javax.swing.*;

import java.awt.event.*;
import java.awt.*;

public class GatewayUsageCounter extends JFrame implements ActionListener {
	 
	ArrayList<AddressCounter> addressSequence = new ArrayList<AddressCounter>();
	private JTextField ipField;
	private JButton computeButton;
	private JLabel feedbackLabel;
	
	public GatewayUsageCounter (){
		setTitle("Gateway Usage Counter");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new BorderLayout());

		// The panel
		JPanel panel = new JPanel(new BorderLayout());
		panel.add(new JLabel("IP Address:"),BorderLayout.WEST);
		ipField = new JTextField(13);
		panel.add(ipField,BorderLayout.CENTER);
		ipField.setActionCommand("RecordIP");
		ipField.addActionListener(this);
		
		computeButton = new JButton("Show Usage");
		computeButton.addActionListener(this);
		panel.add(computeButton, BorderLayout.EAST);
		
		feedbackLabel = new JLabel("Enter an IP address");
		panel.add(feedbackLabel,BorderLayout.SOUTH);
		
		add(panel);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equalsIgnoreCase("RecordIP")){	
			AddressCounter anAddressCounter = new AddressCounter(ipField.getText());
			
			//Look through addressSequence to see if we've seen this address before
			int index = -1;
			for (int i = 0; i < addressSequence.size(); i++){
				AddressCounter currentAddressCounter = addressSequence.get(i);
				if (currentAddressCounter.getAddress().equals(anAddressCounter.getAddress())){
					currentAddressCounter.incrementCount();
					index = i;
				}
			}
			if (index < 0) // new address, add it to the arraylist
				addressSequence.add(anAddressCounter);
			
			ipField.setText("");
			feedbackLabel.setText("IP address recorded.  Enter another IP address.");	
		}
		else{
			System.out.println("\nGateway Accesses by IP Address\n\n"
					+ "-------------------------\n"
					+ "IP Address     : Accesses\n"
					+ "-------------------------");

			for (int i = 0; i < addressSequence.size(); i++)
				System.out.println( addressSequence.get(i) );
		}
	}
	
	public static void main(String[] args) {
		GatewayUsageCounter controller = new GatewayUsageCounter();
		controller.pack();
		controller.setVisible(true);
	}

}
