package c12lists.text.characterdrill.characterdrill2;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Scanner;

public class CharacterDrill {

	private List<Character> myCharacters;
	private int myAnswerIndex, myHintCount;

	private Random myRandom;

	public CharacterDrill(String path) {
		myCharacters = new ArrayList<Character>();
		myCharacters.add(new Character("I", "wo3", path + "wo3.gif"));
		myCharacters.add(new Character("you", "ni3", path + "ni3.gif"));
		myCharacters.add(new Character("he", "ta1", path + "ta1he.gif"));
		myCharacters.add(new Character("she", "ta1", path + "ta1she.gif"));
		myCharacters.add(new Character("it", "ta1", path + "ta1it.gif"));
		myRandom = new Random();
		reset();
	}

	public CharacterDrill(String path, String filename) throws FileNotFoundException {
		myCharacters = loadCharacters(path + filename);
		myRandom = new Random();
		reset();
	}

	public void reset() {
		myAnswerIndex = myRandom.nextInt(myCharacters.size());
		myHintCount = 0;
	}

	private List<Character> loadCharacters(String filename) throws FileNotFoundException {
		Scanner fileIn = new Scanner(new File(filename));
		List<Character> result = new ArrayList<Character>();
		while (fileIn.hasNext()) {
			result.add(new Character(fileIn.next(), fileIn.next(), fileIn.next()));
		}
		fileIn.close();
		return result;
	}

	public boolean guess(String guess) {
		return myCharacters.get(myAnswerIndex).getEnglishTranslation().equalsIgnoreCase(guess);
	}

	public String getAnswer() {
		return myCharacters.get(myAnswerIndex).getEnglishTranslation();
	}

	public String getHintText() {
		myHintCount++;
		if (myHintCount == 1) {
			return "Translate this character.";
		} else if (myHintCount == 2) {
			return "PinYin: " + myCharacters.get(myAnswerIndex).getPinyin();
		} else {
			return "No more hints...";
		}
	}

	public String getHintImageFilename() {
		return myCharacters.get(myAnswerIndex).getImageFilename();
	}

}
