package c12lists.text.characterdrill.characterdrill2;

import java.net.URISyntaxException;

import processing.core.PApplet;
import processing.core.PImage;

/**
 * CharacterDrillPanel supports the display of images and playing of audio clips
 * for the CharacterDrill application.
 * 
 * You must include the Minim audio libraries in your build path; find them in
 * the standard code repository.
 * 
 * Images taken from http://chineseculture.about.com
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class CharacterDrillPanel extends PApplet {

	private PImage myImage;
	private int myTintValue;

	public CharacterDrillPanel() {
	}

	public CharacterDrillPanel(String imageFilename, String pronunciationFilename) throws URISyntaxException {
		setImage(imageFilename);
	}

	public void setImage(String filename) throws URISyntaxException {
		myImage = loadImage(filename);
		myTintValue = 0;
	}

	public void setup() {
		size(300, 300);
		background(255);
		imageMode(CENTER);
	}

	public void draw() {
		if (myImage != null) {
			tint(255, myTintValue);
			image(myImage, width / 2, height / 2);
			myTintValue = constrain(myTintValue + 1, 0, 255);
		}
	}

}
