package c12lists.text.characterdrill.characterdrillOld;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class CharacterDrill0 {

	private List<Character> myCharacters;
	private int myAnswerIndex, myHintCount;

	private Random myRandom;

	public CharacterDrill0() {
		myCharacters = new ArrayList<Character>();
		myCharacters.add(new Character("I", "wo3", "wo3.gif", "wo3.wav"));
		myCharacters.add(new Character("you", "ni3", "ni3.gif", "ni3.wav"));
		myCharacters.add(new Character("he", "ta1", "ta1he.gif", "ta1.wav"));
		myCharacters.add(new Character("she", "ta1", "ta1she.gif", "ta1.wav"));
		myCharacters.add(new Character("it", "ta1", "ta1it.gif", "ta1.wav"));
		myRandom = new Random();
		reset();
	}
	
	public void reset() {
		myAnswerIndex = myRandom.nextInt(myCharacters.size());
		myHintCount = 0;
	}

	public boolean guess(String guess) {
		return myCharacters.get(myAnswerIndex).getEnglishTranslation().equalsIgnoreCase(guess);
	}

	public String getAnswer() {
		return myCharacters.get(myAnswerIndex).getEnglishTranslation();
	}

	public String getHintText() {
		myHintCount++;
		switch (myHintCount) {
		case 1:
			return "Translate the character shown above.";
		case 2:
			return "PinYin pronounciation: " + myCharacters.get(myAnswerIndex).getPinyin();
		default:
			return "No more hints...";
		}
	}

	public String getHintImageFilename() {
		return myCharacters.get(myAnswerIndex).getImageFilename();
	}

	public String getHintPronunciationFilename() {
		return myCharacters.get(myAnswerIndex).getPronunciationFilename();
	}

}
