package c12lists.text.characterdrill.characterdrillOld;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Scanner;

public class CharacterDrill1 {

	private List<Character> myCharacters;
	private int myAnswerIndex, myHintCount;

	private Random myRandom;

	public CharacterDrill1() {
		myCharacters = new ArrayList<Character>();
		myCharacters.add(new Character("I", "wo3", "wo3.gif", "wo3.wav"));
		myCharacters.add(new Character("you", "ni3", "ni3.gif", "ni3.wav"));
		myCharacters.add(new Character("he", "ta1", "ta1he.gif", "ta1.wav"));
		myCharacters.add(new Character("she", "ta1", "ta1she.gif", "ta1.wav"));
		myCharacters.add(new Character("it", "ta1", "ta1it.gif", "ta1.wav"));
		myRandom = new Random();
		reset();
	}

	public CharacterDrill1(String filename) throws FileNotFoundException {
		myCharacters = loadCharacters(filename);
		myRandom = new Random();
		reset();
	}

	public void reset() {
		myAnswerIndex = myRandom.nextInt(myCharacters.size());
		myHintCount = 0;
	}

	private List<Character> loadCharacters(String filename) throws FileNotFoundException {
		Scanner scanner = new Scanner(new File(filename));
		List<Character> result = new ArrayList<Character>();
		while (scanner.hasNext()) {
			result.add(new Character(scanner.next(), scanner.next(), scanner.next(), scanner.next())); 
		}
		scanner.close();
		return result;
	}

	public boolean guess(String guess) {
		return myCharacters.get(myAnswerIndex).getEnglishTranslation().equalsIgnoreCase(guess);
	}

	public String getAnswer() {
		return myCharacters.get(myAnswerIndex).getEnglishTranslation();
	}

	public String getHintText() {
		myHintCount++;
		switch (myHintCount) {
		case 1:
			return "Translate the character shown above.";
		case 2:
			return "PinYin: " + myCharacters.get(myAnswerIndex).getPinyin();
		default:
			return "No more hints...";
		}
	}

	public String getHintImageName() {
		return myCharacters.get(myAnswerIndex).getImageFilename();
	}
	
	public String getHintPronunciation() {
		return myCharacters.get(myAnswerIndex).getPronunciationFilename();
	}

}
