package c12lists.text.characterdrill.characterdrillOld;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.net.URISyntaxException;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * ChineseDrillController implements a simple Chinese character review application.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
@SuppressWarnings("serial")
public class CharacterFileBuilderController extends JFrame implements ActionListener {

	private JLabel messageLabel;
	private JTextField englishField, pinyinField, imageFilenameField, soundFilenameField, sentenceField;
	private JButton addButton, closeButton;
	private PrintWriter outFile;

	public CharacterFileBuilderController() throws URISyntaxException, FileNotFoundException {
		setTitle("Chinese Character Creator");
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		Font font = new Font("Ariel", 0, 18);

		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setDialogTitle("Choose an output filename");
		fileChooser.showOpenDialog(this);
		outFile = new PrintWriter(fileChooser.getSelectedFile());

		messageLabel = new JLabel("Please add a character.");
		messageLabel.setFont(font);
		add(messageLabel, BorderLayout.CENTER);

		JPanel addController = new JPanel();
		addController.setLayout(new FlowLayout());
		JLabel englishLabel = new JLabel("English: ");
		englishLabel.setFont(font);
		addController.add(englishLabel);
		englishField = new JTextField(7);
		englishField.setFont(font);
		addController.add(englishField);
		JLabel pinyinLabel = new JLabel("PinYin: ");
		pinyinLabel.setFont(font);
		addController.add(pinyinLabel);
		pinyinField = new JTextField(7);
		pinyinField.setFont(font);
		addController.add(pinyinField);
		JLabel imageFilenameLabel = new JLabel("Image: ");
		imageFilenameLabel.setFont(font);
		addController.add(imageFilenameLabel);
		imageFilenameField = new JTextField(7);
		imageFilenameField.setFont(font);
		addController.add(imageFilenameField);
		JLabel soundFilenameLabel = new JLabel("Sound: ");
		soundFilenameLabel.setFont(font);
		addController.add(soundFilenameLabel);
		soundFilenameField = new JTextField(7);
		soundFilenameField.setFont(font);
		addController.add(soundFilenameField);
		JLabel sentenceLabel = new JLabel("Sentence: ");
		sentenceLabel.setFont(font);
		addController.add(sentenceLabel);
		sentenceField = new JTextField(14);
		sentenceField.setFont(font);
		addController.add(sentenceField);

		addButton = new JButton("Add");
		addButton.addActionListener(this);
		addController.add(addButton);
		closeButton = new JButton("Close");
		closeButton.addActionListener(this);
		addController.add(closeButton);
		add(addController, BorderLayout.SOUTH);

	}

	@Override
	public void actionPerformed(ActionEvent event) {
		String actionCommand = event.getActionCommand();
		if (actionCommand.equalsIgnoreCase("Add")) {
			outFile.print(englishField.getText() + " " + pinyinField.getText() + " " + imageFilenameField.getText() + " " + soundFilenameField.getText() + " " + sentenceField.getText());
			messageLabel.setText("Record added...");
		} else if (actionCommand.equalsIgnoreCase("Close")) {
			outFile.close();
			messageLabel.setText("File saved...");
		}
	}

	public static void main(String[] args) throws URISyntaxException, FileNotFoundException {
		CharacterFileBuilderController application = new CharacterFileBuilderController();
		application.pack();
		application.setVisible(true);
	}

}
