package c12lists.text.integerStatistics;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class FileReadConsole {
	
	public static String PATH = "src/c12lists/text/integerStatistics/";

	public static double computeAverage(List<Integer> values) throws Exception {
		if (values == null || values.size() == 0) {
			throw new Exception("Empty list");
		}
		int sum = 0;
		for (int i = 0; i < values.size(); i++) {
			sum += values.get(i);
		}
		return sum / values.size();
	}

	public static double computeVariance(List<Integer> values, double average) throws Exception {
		if (values == null || values.size() == 0) {
			throw new Exception("Empty list");
		}
		int sum = 0;
		for (int i = 0; i < values.size(); i++) {
			sum += Math.pow(values.get(i) - average, 2);
		}
		return Math.sqrt(sum / values.size());
	}

	public static void main(String[] args) throws Exception {
		Scanner keyboard = new Scanner(System.in);
		System.out.print("Data Records filename: ");
		String filename = keyboard.nextLine();
		
		List<Integer> scores = new ArrayList<Integer>();
		Scanner fileIn = new Scanner(new File(PATH + filename));
		while (fileIn.hasNext()) {
			scores.add(fileIn.nextInt());
		}
		fileIn.close();
		double average = computeAverage(scores);
		System.out.printf("average: %5.2f%n", average);
		System.out.printf("std dev: %5.2f%n", computeVariance(scores, average));
	}

}
