package c13oop.lecture.payroll;

public class HourlyEmployee extends Employee {

	private static final double WORK_WEEK = 40.0, OVERTIME_RATE = 1.5;

	private double myPayrate, myHours;

	public HourlyEmployee() {
		myPayrate = myHours = 0.0;
	}

	public HourlyEmployee(int id, String name, String role, double payrate, double hours) {
		super(id, name, role);
		myPayrate = payrate;
		myHours = hours;
	}
	
	public double getPayrate() { return myPayrate; }
	public void setPayrate(double payrate) { myPayrate = payrate; }
	public double getHours() { return myHours; }
	public void setHours(double hours) { myHours= hours; }

	@Override
	public double computePay() {
		if (myHours <= WORK_WEEK) {
			return myPayrate * myHours;
		} else {
			return (myPayrate * WORK_WEEK) + ((myPayrate * OVERTIME_RATE) * (myHours - WORK_WEEK));
		}
	}
	
	@Override
	public String toString() {
		return super.toString() + "\n\tPayrate: " + myPayrate + "\n\tHours worked: " + myHours;
	}

}
