package c13oop.lecture.payrollOld;

/** Employee.java provides a class (abstract) to model employees.  
 *  Attribute variables store an employee's name and ID number.  
 *  Methods:  Constructors: default and one to construct an Employee
 *            from a name and ID number; accessors; to-string converter
 *            for output purposes; reader to read a name and ID number
 */

import java.util.Scanner;

abstract class Employee extends Object
{
 //--- Employee default constructor ---
 public Employee()
 {
   myName = "";
   myID = -1;
 }

 //--- Employee explicit-value constructor ---
 public Employee(String name, int id)
 {
   myName = name;
   myID = id;          // validation omitted
 }
 
 //--- Accessor methods ---
 public String name() { return myName; }
 public int id()      { return myID;   }
 
 //--- String converter (for output) ---
 public String toString() { return myName + "\n" + myID; }
 
 

//--- File input ---
 void read(Scanner reader)
 {
   try
   {
     myName = reader.next();
     myID   = reader.nextInt();
   }
   catch (Exception error)
   {
     System.err.println("Employee:read(): " + error);
     System.exit(1);
   }
 }
 
 //--- Abstract pay method ---
 abstract public double pay();

 //--- Attribute variables ---
 private String myName;
 private int    myID;
}
