package c13oop.lecture.payrollOld;

/** HourlyEmployee.java provides a subclass of Employee to model hourly
 *  employees. New attribute variable stores employee's salary.  
 *  Constants: OVERTIME_THRESHOLD  = 40;  OVERTIME_FACTOR = 1.5
 *  Methods: Constructors: default and one to construct an HourlyEmployee
 *           from a name, ID number, hourly rate, and hours worked;    
 *           accessors;  pay calculator;  
 *           to-string converter for output purposes;  
 *           reader to read a name,ID number, hourly rate, and hours worked
 *  @see Employee
 */

import java.util.Scanner;

class HourlyEmployee extends Employee
{
 public final static double OVERTIME_THRESHOLD  = 40;
 public final static double OVERTIME_FACTOR     = 1.5;

 //--- HourlyEmployee default constructor ---
 public HourlyEmployee()
 {
   super();
   myHourlyRate = myHours = 0.0;
 }
  
 //--- HourlyEmployee explicit-value constructor ---
 public HourlyEmployee(String name, int id, double rate, double hours)
 {
   super(name, id); 
   myHourlyRate = rate; 
   myHours = hours;
 }
  
 //--- Accessor methods ---
 public double hourlyRate() { return myHourlyRate; }
 public double hours()      { return myHours; }
 
 //--- Pay for hourly employee ---
 public double pay()
 {
   if (myHours <= OVERTIME_THRESHOLD)
     return myHours * myHourlyRate;
   else
     return OVERTIME_THRESHOLD * myHourlyRate +
              (myHours - OVERTIME_THRESHOLD) * 
                myHourlyRate * OVERTIME_FACTOR;
  }

 //--- String converter (for output) ---
 public String toString()
 {
   return super.toString() + " " + myHourlyRate + " " + myHours;
 }

 //--- File input ---
 void read(Scanner reader)
 {
   super.read(reader);
   try
   {
     myHourlyRate  = reader.nextDouble(); 
     myHours = reader.nextInt();
   }
   catch (Exception e)
   {
     System.err.println("HourlyEmployee:read() " + e);
     System.exit(1);
   }
 }
 
 //--- Attribute variables ---
 private double myHourlyRate;
 private double myHours;
}