package c13oop.lecture.payrollOld;

/** PayrollGenerator.java calculates wages and prepares paychecks
 *  for employees:
 *  Input:  employee records (from a file)
 *  Output: paycheck information
 *  @see Employee
 *  @see Paycheck
 */

import java.io.*;        
import java.util.*;

class PayrollGenerator
{
public static void main(String [] args)
{
   ArrayList<Employee> employees = readFile(args[0]);
   
   for (int i = 0; i < employees.size(); i++)
   {
      Paycheck check = new Paycheck(employees.get(i));
      System.out.println(check + "\n");
   }
 }

public static ArrayList<Employee> readFile(String fileName)
{
	ArrayList<Employee> result = new ArrayList<Employee>();
	try
	{
		Scanner empFile = new Scanner (new File(fileName));
		int i = 0;

		String className = "";
		while(empFile.hasNext())
		{
			className = empFile.next();
			result.add((Employee) Class.forName(className).newInstance());
			result.get(i).read(empFile);
			i++;
		}

			empFile.close();
		}
		catch (Exception e)
		{
			System.err.println(e); System.exit(1);
		}

		return result;
	}

}