package c13oop.lecture.payrollOld;
/** SalariedEmployee.java provides a subclass of Employee to model salaried
 *  employees. New attribute variable stores employee's salary.  
 *  Methods: Constructors: default and one to construct a SalariedEmployee
 *           from a name, ID number, and salary;   accessors; 
 *           pay calculator;  to-string converter for output purposes;  
 *           reader to read a name, ID number, and salary.
 *  @see Employee
 */

import java.util.Scanner;                      

class SalariedEmployee extends Employee
{
 //--- SalariedEmployee default constructor ---
 public SalariedEmployee()
 {
   super();
   mySalary = 0.0;
 }
  
 //--- SalariedEmployee explicit-value constructor ---
 public SalariedEmployee(String name, int id, double salary)
 {
   super(name, id);
   mySalary = salary;
 }

 //--- Accessor methods ---
 public double salary() { return mySalary; }
 public double pay()    { return salary(); }

 //--- String converter (for output) ---
 public String toString() 
 { 
   return super.toString() + "\n" + mySalary;
 }

 //--- File input ---
 void read(Scanner reader)
 {
   super.read(reader);
   try
   {
     mySalary = reader.nextDouble();
   }
   catch (Exception error)
   {
     System.err.println("SalariedEmployee:read(): " + error);
     System.exit(1);
   }
 }
 
 //--- Attribute variables ---
 private double mySalary;
}