package c13oop.text.vehiclesAbstract;

abstract class Vehicle {

	private String myBrand, myModel;

	public Vehicle() {
		myBrand = "unknown";
		myModel = "unknown";
	}

	public Vehicle(String brand, String model) {
		setBrand(brand);
		setModel(model);
	}

	public String getBrand() {
		return myBrand;
	}

	public void setBrand(String brand) {
		myBrand = brand;
	}

	public String getModel() {
		return myModel;
	}

	public void setModel(String model) {
		myModel = model;
	}

	// Declare this as abstract because it doesn't make any sense to guess what
	// the locomotion would be. With toString(), there is something general to
	// return, with this method there really isn't.
	// The Simpledraw example is better because here there is some value one
	// could imagine returning from this locomotion method, but in simpledraw
	// there is nothing that we could actually draw that would approximate a
	// generic "figure".
	public abstract String getLocomotion();

	public String toString() {
		return getBrand() + " " + getModel();
	}

}
